// ============================ Atmega128 CPU ׽Ʈ α׷ =================
//  CPU : ATmega128-16M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#include <mega128.h>						// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>
#include <math.h>

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ
// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
char com2_rx_data,com2_rx_eflg = 0;				// COM2   ͷƮ  /÷

int timer0_cnt = 0;						// Ÿ̸0 ͷƮ  ī
int timer1_cnt = 0;						// Ÿ̸1 ͷƮ  ī
int timer2_cnt = 0;						// Ÿ̸2 ͷƮ  ī
int timer3_cnt = 0;						// Ÿ̸3 ͷƮ  ī

int exint0_flg = 0;						// EXINT0 ͷƮ  ÷
int exint1_flg = 0;						// EXINT1 ͷƮ  ÷
int exint2_flg = 0;						// EXINT2 ͷƮ  ÷
int exint3_flg = 0;						// EXINT3 ͷƮ  ÷
int exint4_flg = 0;						// EXINT4 ͷƮ  ÷
int exint5_flg = 0;						// EXINT5 ͷƮ  ÷
int exint6_flg = 0;						// EXINT6 ͷƮ  ÷
int exint7_flg = 0;						// EXINT7 ͷƮ  ÷

unsigned int adc_int_data = 0;					// ADC ͷƮ  
int adc_int_ch = 0;						// ADC CH ͷƮ 
int adc_int_flg = 0;						// ADC ͷƮ  ÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{

// PortA 
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)
// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortC 
	PORTC=0x00;						// Ʈ  reg
	DDRC=0x00;                                              // Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// PortE 
	PORTE=0x00;						// Ʈ  reg
	DDRE=0x00;                                              // Ʈ  reg(0Է,1)
// PortF 
	PORTF=0x00;						// Ʈ  reg
	DDRF=0x00;                                              // Ʈ  reg(0Է,1)
// PortG 
	PORTG=0x00;						// Ʈ  reg
	DDRG=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
	ASSR=0x00;
	TCCR0=0x00;
	TCNT0=0x00;
	OCR0=0x00;

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;
	OCR1CH=0x00;
	OCR1CL=0x00;

// Timer/Counter2 
	TCCR2=0x00;
	TCNT2=0x00;
	OCR2=0x00;

// Timer/Counter3 
	TCCR3A=0x00;
	TCCR3B=0x00;
	TCNT3H=0x00;
	TCNT3L=0x00;
	OCR3AH=0x00;
	OCR3AL=0x00;
	OCR3BH=0x00;
	OCR3BL=0x00;
	OCR3CH=0x00;
	OCR3CL=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
	EICRA=0x00;
	EICRB=0x00;
	EIMSK=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK=0x00;
	ETIMSK=0x00;

//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x33;

//  ʱȭ(COM2)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR1A=0x00;
	UCSR1B=0x98;
	UCSR1C=0x06;
	UBRR1H=0x00;
	UBRR1L=0x33;

// External SRAM page configuration:
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): None
//	MCUCR=0x80;
//	XMCRA=0x00;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

// Global enable interrupts
#asm("sei")
}

// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [USART0_RXC] void uart0_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=UCSR0A;
	data=UDR0;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+


// ============================== COM2  ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [USART1_RXC] void uart1_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=UCSR1A;
	data=UDR1;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com2_rx_data = data;
		com2_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
	TCNT0 = 99;						// 255-156 = 100
	timer0_cnt++;						// Ÿ̸0 ī
}

// ========================== TIMER1 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
// ----------------------------------------------------------------------------
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
	TCNT1 = 63035;						// 65535 - 2500 = 63035
	timer1_cnt++;						// Ÿ̸1 ī
}

// ========================== TIMER2 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
	TCNT2 = 99;						// 255-156 = 100
	timer2_cnt++;						// Ÿ̸2 ī
}

// ========================== TIMER3 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
// ----------------------------------------------------------------------------
interrupt [TIM3_OVF] void timer3_ovf_isr(void)
{
	TCNT3H=0xf6;  						// 65535 - 2500 = 63035
	TCNT3L=0x3b;
	timer3_cnt++;						// Ÿ̸3 ī
}

// ========================== ܺ INT0 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [EXT_INT0] void ext_int0_isr(void)
{
	exint0_flg = 1;						// EXINT0 ÷ ON
}

// ========================== ܺ INT1 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [EXT_INT1] void ext_int1_isr(void)
{
	exint1_flg = 1;						// EXINT1 ÷ ON
}

// ========================== ܺ INT2 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [EXT_INT2] void ext_int2_isr(void)
{
	exint2_flg = 1;						// EXINT2 ÷ ON
}

// ========================== ܺ INT3 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [EXT_INT3] void ext_int3_isr(void)
{
	exint3_flg = 1;						// EXINT3 ÷ ON
}

// ========================== ܺ INT4 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [EXT_INT4] void ext_int4_isr(void)
{
	exint4_flg = 1;						// EXINT4 ÷ ON
}

// ========================== ܺ INT5 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [EXT_INT5] void ext_int5_isr(void)
{
	exint5_flg = 1;						// EXINT5 ÷ ON
}

// ========================== ܺ INT6 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [EXT_INT6] void ext_int6_isr(void)
{
	exint6_flg = 1;						// EXINT6 ÷ ON
}

// ========================== ܺ INT7 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [EXT_INT7] void ext_int7_isr(void)
{
	exint7_flg = 1;						// EXINT7 ÷ ON
}

// =============================== ADC ͷƮ ===============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [ADC_INT] void adc_isr(void)
{
	adc_int_data = ADCW;					// ADC
	adc_int_flg = 1;					// ADC Ϸ ÷ 
}

// Լ 
void main_menu_disp(void);					//  ޴ ǥ
void cpu_ioport_output(void);					// CPU PORT I/O ׽Ʈ
void timer0_test(void);						// TIMER0 TEST
void timer1_test(void);						// TIMER1 TEST
void timer2_test(void);						// TIMER2 TEST
void timer3_test(void);						// TIMER3 TEST
void exint_test(void);						// EXINT0,1 TEST

void ad_polling_test(void);					// A/D   TEST
unsigned int ad_read(unsigned char adc_input);			// A/D  ( )
void ad_interrupt_test(void);					// A/D ͷƮ  TEST
void ad_start(unsigned char adc_input);				// AD  (ͷƮ )

void eeprom_test(void);						// EEPROM TEST
void EEPROM_write(int addr,unsigned char data);			// EEPROM  
unsigned char EEPROM_read(int addr);				// EEPROM  

void sram_test(void);						// SRAM TEST

void com2_test(void);						// COM2 TEST
void putchar1(char c);						// COM2 1Ʈ ۽

void urx_string(char buff[]);					// Ʈ 
long atoh(char buff[]);						// ASCII TO HEX 

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
void main(void)
{
	cpu_setup();						// cpuʱȭ
	main_menu_disp();					//  ޴ ǥ
	while(1){						// Place your code here
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
			else if(com1_rx_data == '2') timer0_test(); // TIMER0 TEST
			else if(com1_rx_data == '3') timer1_test(); // TIMER1 TEST
			else if(com1_rx_data == '4') timer2_test(); // TIMER2 TEST
			else if(com1_rx_data == '5') timer3_test(); // TIMER3 TEST
			else if(com1_rx_data == '6') exint_test();  // EXINT0,1 TEST
			else if(com1_rx_data == '7') ad_polling_test();// A/D POLLING TEST
			else if(com1_rx_data == '8') ad_interrupt_test(); // A/D POLLING TEST
			else if(com1_rx_data == '9') eeprom_test(); // EEPROM TEST
			else if(com1_rx_data == 'a') sram_test();// SRAM TEST
			else if(com1_rx_data == 'b') com2_test();// COM2 TEST
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
}

// =====================================  ޴ ǥ =======================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("=================== MAIN MENU ==================\r\n");
	printf("- 1  : CPU I/O PORT TEST                        \r\n");
	printf("- 2  : TIMER0 TEST                              \r\n");
	printf("- 3  : TIMER1 TEST                              \r\n");
	printf("- 4  : TIMER2 TEST                              \r\n");
	printf("- 5  : TIMER3 TEST                              \r\n");
	printf("- 6  : EXINT0,1,2,3,4,5,6,7 TEST                \r\n");
	printf("- 7  : A/D POLLING   TEST                       \r\n");
	printf("- 8  : A/D INTERRUPT TEST                       \r\n");
	printf("- 9  : EEPROM TEST                              \r\n");
	printf("- a  : SRAM   TEST                              \r\n");
	printf("- b  : COM2   TEST                              \r\n");
	printf("----------------- CPUPLAZA ---------------------\r\n");
}

// ============================== CPU_IO TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void cpu_ioport_output(void)
{
int out_cnt,exit_flg = 0;

	printf("================ CPU I/O PORT TEST ==============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("-------------------------------------------------\r\n");
// CPU PORT   
// PORTA[0..7] : OUT
	PORTA=0xff;						// Ʈ  reg
	DDRA=0xff;						// Ʈ  reg(0Է,1)
// CPU PORT   
// PORTB[0..7] : OUT
	PORTB=0xff;						// Ʈ  reg
	DDRB=0xff;						// Ʈ  reg(0Է,1)
// PORTC[0..5] : OUT
	PORTC=0xff;						// Ʈ  reg
	DDRC=0xff;						// Ʈ  reg(0Է,1)
// PORTD[0..7] : OUT
	PORTD=0xff;						// Ʈ  reg
	DDRD=0xff;						// Ʈ  reg(0Է,1)
// PORTE[2..7] : OUT
	PORTE=0xfc;						// Ʈ  reg
	DDRE=0xfc;						// Ʈ  reg(0Է,1)
// PORTF[0..7] : OUT
	PORTF=0xff;						// Ʈ  reg
	DDRF=0xff;						// Ʈ  reg(0Է,1)
// PORTG[0..2] : OUT
	PORTG=0x07;						// Ʈ  reg
	DDRG=0x07;						// Ʈ  reg(0Է,1)

// LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
// Timer/Counter0 (Overflow)
	ASSR=0x00;
	TCCR0 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;						// 255-156 = 99
	OCR0=0x00;
	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡

	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	out_cnt = 0;
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 50){				// 500ms  
			if(out_cnt >= 0 && out_cnt < 8) PORTA = ~(1 << out_cnt);// PORTA (ش Ʈ 0)
			else if(out_cnt >= 8 && out_cnt < 16){	// PORTB 
				if(out_cnt == 8) PORTA = 0xff;	// PORTA CLEAR
				PORTB = ~(1 << (out_cnt-8));	// PORTB (ش Ʈ 0)
			}
			else if(out_cnt >= 16 && out_cnt < 24){	// PORT C 
				if(out_cnt == 16) PORTB = 0xff;	// PORTB CLEAR
				PORTC = ~(1 << (out_cnt-16));	// PORTC (ش Ʈ 0)
			}
			else if(out_cnt >= 24 && out_cnt < 32){	// PORTD 
				if(out_cnt == 24) PORTC = 0xff;	// PORTC CLEAR
				PORTD = ~(1 << (out_cnt-24));	// PORTD (ش Ʈ 0)
			}
			else if(out_cnt >= 32 && out_cnt < 38){	// PORTE 
				if(out_cnt == 32) PORTD = 0xff;	// PORTD CLEAR
				PORTE = ~(4 << (out_cnt-32));	// PORTE (ش Ʈ 0)
			}
			else if(out_cnt >= 38 && out_cnt < 46){	// PORTF 
				if(out_cnt == 38) PORTE = 0xfc;	// PORTE CLEAR
				PORTF = ~(1 << (out_cnt-38));	// PORTF (ش Ʈ 0)
			}
			else if(out_cnt >= 46 && out_cnt < 49){	// PORTG 
				if(out_cnt == 46) PORTF = 0xff;	// PORTF CLEAR
				PORTG = ~(1 << (out_cnt-46));	// PORTG (ش Ʈ 0)
			}
			out_cnt++;				//  ġ ī 
			if(out_cnt >= 50) out_cnt = 0;		//  ġ ʰ ˻
			if(out_cnt == 0){			//  ü ʱȭ
				PORTA = 0xff;
				PORTB = 0xff;
				PORTC = 0xff;
				PORTD = 0xff;
				PORTE = 0xfc;
				PORTF = 0xff;
				PORTG = 0x07;
			}
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	ASSR = 0x00;
	TCCR0 = 0x00;
	TCNT0 = 0;
	OCR0=0x00;
	TIMSK &= 0xfe;						// TIMER0 ͷƮ 

// CPU PORT ʱⰪ  
// PORTA
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)
// PORTB
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)
// PORTC
	PORTC=0x00;						// Ʈ  reg
	DDRC=0x00;						// Ʈ  reg(0Է,1)
// PORTD
	PORTD=0x00;						// Ʈ  reg
	DDRD=0x00;						// Ʈ  reg(0Է,1)
// PORTE
	PORTE=0x00;						// Ʈ  reg
	DDRE=0x00;						// Ʈ  reg(0Է,1)
// PORTF
	PORTF=0x00;						// Ʈ  reg
	DDRF=0x00;						// Ʈ  reg(0Է,1)
// PORTG
	PORTG=0x00;						// Ʈ  reg
	DDRG=0x00;						// Ʈ  reg(0Է,1)

	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER0 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer0_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER0 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER0 Overfow 9.9984ms         \r\n");
	printf("- message disp : 9.9984ms * 100 = 999.84ms       \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter0 (Overflow)
	ASSR=0x00;
	TCCR0 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;						// 255-156 = 99
	OCR0=0x00;
	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡

	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 100){				// 999.84ms üũ
			printf("TIMER0 Overflow Interrupt\r\n");
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	ASSR = 0x00;
	TCCR0 = 0x00;
	TCNT0 = 0;
	OCR0=0x00;
	TIMSK &= 0xfe;						// TIMER0 ͷƮ 

	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER1 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer1_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER1 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER1 Overfow 10.0ms           \r\n");
	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter1 (Overflow)
	TCCR1A=0x00;
	TCCR1B=0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	TCNT1 = 63035;						// 65535 - 2500 = 63035
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;
	OCR1CH=0x00;
	OCR1CL=0x00;
	TIMSK |= 0x04;						// TIMER1 ͷƮ 㰡

	timer1_cnt = 0;						// TIMER1 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){					// COM1  ˻
		if(com1_rx_eflg){
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer1_cnt >= 100){				// 1s üũ
			printf("TIMER1 Overflow Interrupt\r\n");
			timer1_cnt = 0;
		}
	}

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;
	OCR1CH=0x00;
	OCR1CL=0x00;
	TIMSK &= 0xfb;						// TIMER1 ͷƮ 

	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER2 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer2_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER2 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER2 Overfow 9.9984ms         \r\n");
	printf("- message disp : 9.9984ms * 100 = 999.84ms       \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter2 (Overflow)
	TCCR2 = 0x05;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT2 = 99;						// 255-156 = 99
	OCR2 = 0x00;
	TIMSK |= 0x40;						// TIMER2 ͷƮ 㰡

	timer2_cnt = 0;						// TIMER2 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer2_cnt >= 100){				// 999.84ms üũ
			printf("TIMER2 Overflow Interrupt\r\n");
			timer2_cnt = 0;
		}
	}

// Timer/Counter2 
	TCCR2 = 0x00;
	TCNT2 = 0;
	OCR2 = 0x00;
	TIMSK &= 0xbf;						// TIMER2 ͷƮ 

	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER3 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer3_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER3 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER3 Overfow 10.0ms           \r\n");
	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter3 (Overflow)
	TCCR3A=0x00;
	TCCR3B=0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	TCNT3H=0xf6;  						// 65535 - 2500 = 63035
	TCNT3L=0x3b;

	OCR3AH=0x00;
	OCR3AL=0x00;
	OCR3BH=0x00;
	OCR3BL=0x00;
	OCR3CH=0x00;
	OCR3CL=0x00;
	ETIMSK |= 0x04;						// TIMER3 ͷƮ 㰡

	timer3_cnt = 0;						// TIMER3 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){					// COM1  ˻
		if(com1_rx_eflg){
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer3_cnt >= 100){				// 1s üũ
			printf("TIMER3 Overflow Interrupt\r\n");
			timer3_cnt = 0;
		}
	}

// Timer/Counter3 
	TCCR3A=0x00;
	TCCR3B=0x00;
	TCNT3H=0x00;
	TCNT3L=0x00;
	OCR3AH=0x00;
	OCR3AL=0x00;
	OCR3BH=0x00;
	OCR3BL=0x00;
	OCR3CH=0x00;
	OCR3CL=0x00;
	ETIMSK &= 0xfb;						// TIMER3 ͷƮ 

	main_menu_disp();					//  ޴ ǥ
}

// ============================== EXINT0,1 TEST ===============================
// [μ]: void
// ----------------------------------------------------------------------------
void exint_test(void)
{
int exit_flg = 0;

	printf("=================== EXINT0,1 TEST ===============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt : INT0 Falling Edge                  \r\n");
	printf("-             INT1 Falling Edge                  \r\n");
	printf("-             INT2 Falling Edge                  \r\n");
	printf("-             INT3 Falling Edge                  \r\n");
	printf("-             INT4 Falling Edge                  \r\n");
	printf("-             INT5 Falling Edge                  \r\n");
	printf("-             INT6 Falling Edge                  \r\n");
	printf("-             INT7 Falling Edge                  \r\n");
	printf("-------------------------------------------------\r\n");

// External Interrupt(s) 
// INT0 Mode: Falling Edge
// INT1 Mode: Falling Edge
// INT2 Mode: Falling Edge
// INT3 Mode: Falling Edge
// INT4 Mode: Falling Edge
// INT5 Mode: Falling Edge
// INT6 Mode: Falling Edge
// INT7 Mode: Falling Edge
	EICRA=0xAA;
	EICRB=0xAA;
	EIMSK=0xFF;
	EIFR=0xFF;

	exint0_flg = exint1_flg = exint2_flg = 0;		// EXINT0,1 ͷƮ ÷ Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(exint0_flg){					// EXINT0 ͷƮ ÷ üũ
			printf("EXINT0 Interrupt\r\n");
			exint0_flg = 0;
		}
		if(exint1_flg){					// EXINT1 ͷƮ ÷ üũ
			printf("EXINT1 Interrupt\r\n");
			exint1_flg = 0;
		}
		if(exint2_flg){					// EXINT2 ͷƮ ÷ üũ
			printf("EXINT2 Interrupt\r\n");
			exint2_flg = 0;
		}
		if(exint3_flg){					// EXINT3 ͷƮ ÷ üũ
			printf("EXINT3 Interrupt\r\n");
			exint3_flg = 0;
		}
		if(exint4_flg){					// EXINT4 ͷƮ ÷ üũ
			printf("EXINT4 Interrupt\r\n");
			exint4_flg = 0;
		}
		if(exint5_flg){					// EXINT5 ͷƮ ÷ üũ
			printf("EXINT5 Interrupt\r\n");
			exint5_flg = 0;
		}
		if(exint6_flg){					// EXINT6 ͷƮ ÷ üũ
			printf("EXINT6 Interrupt\r\n");
			exint6_flg = 0;
		}
		if(exint7_flg){					// EXINT7 ͷƮ ÷ üũ
			printf("EXINT7 Interrupt\r\n");
			exint7_flg = 0;
		}
	}

// External Interrupt(s) 
	EICRA=0x00;
	EICRB=0x00;
	EIMSK=0x00;
	EIFR=0x00;

	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: void
// ----------------------------------------------------------------------------
void ad_polling_test(void)
{
unsigned datau;
int exit_flg = 0;

	printf("================= A/D POLLING TEST ==============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- 1  : CH0 READ                                  \r\n");
	printf("- 2  : CH1 READ                                  \r\n");
	printf("- 3  : CH2 READ                                  \r\n");
	printf("- 4  : CH3 READ                                  \r\n");
	printf("- 5  : CH4 READ                                  \r\n");
	printf("- 6  : CH5 READ                                  \r\n");
	printf("- 7  : CH6 READ                                  \r\n");
	printf("- 8  : CH7 READ                                  \r\n");
	printf("-------------------------------------------------\r\n");

// ADC initialization 
	ADMUX = 0x00;						//   AREF
	ADCSRA = 0x87;						// ADC Enable,ADC Clock 125.000Khz
	SFIOR &= 0xEF;

	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1') datau = ad_read(0);// CH0 
			else if(com1_rx_data == '2') datau = ad_read(1);// CH1 
			else if(com1_rx_data == '3') datau = ad_read(2);// CH2 
			else if(com1_rx_data == '4') datau = ad_read(3);// CH3 
			else if(com1_rx_data == '5') datau = ad_read(4);// CH4 
			else if(com1_rx_data == '6') datau = ad_read(5);// CH5 
			else if(com1_rx_data == '7') datau = ad_read(6);// CH6 
			else if(com1_rx_data == '8') datau = ad_read(7);// CH7 
			else putchar(com1_rx_data);		// ݼ
			// A/D  ǥ
			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("ADC CH%d > %d\r\n",(com1_rx_data&0x0f)-1,datau);
			com1_rx_eflg = 0;
		}
	}

// ADC initialization 
	ADMUX = 0x00;
	ADCSRA = 0x00;
	SFIOR &= 0xEF;

	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: unsigned char adc_input
// ITEM1 : AD CH(0-7)
// []: A/D 10bit
// ----------------------------------------------------------------------------
unsigned int ad_read(unsigned char adc_input)
{
	ADMUX = adc_input;					// ADREF(0) + CH
	ADCSRA |= 0x40;						// AD conversion 
	while((ADCSRA & 0x10) == 0);				//  Ϸ 
	ADCSRA |= 0x10;						// AD ÷ Ŭ
	return ADCW;
}

// ============================== A/D INTERRUPT TEST ==========================
// [μ]: void
// ----------------------------------------------------------------------------
void ad_interrupt_test(void)
{
int exit_flg = 0;

	printf("================ A/D INTEERRUPT TEST ============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- 1  : CH0 READ                                  \r\n");
	printf("- 2  : CH1 READ                                  \r\n");
	printf("- 3  : CH2 READ                                  \r\n");
	printf("- 4  : CH3 READ                                  \r\n");
	printf("- 5  : CH4 READ                                  \r\n");
	printf("- 6  : CH5 READ                                  \r\n");
	printf("- 7  : CH6 READ                                  \r\n");
	printf("- 8  : CH7 READ                                  \r\n");
	printf("-------------------------------------------------\r\n");

// ADC initialization 
	ADMUX = 0x00;						//   AREF
	ADCSRA = 0x8f;						// ADC Enable,ADC Clock 125.000Khz,ADC ȯ ͷƮ Ȱȭ
	SFIOR &= 0xEF;

	adc_int_flg = 0;					// ADCϷ ͷƮ ÷
	adc_int_ch = 0;						// ADC CH = CH0
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1') ad_start(0);// CH0 
			else if(com1_rx_data == '2') ad_start(1);// CH1 
			else if(com1_rx_data == '3') ad_start(2);// CH2 
			else if(com1_rx_data == '4') ad_start(3);// CH3 
			else if(com1_rx_data == '5') ad_start(4);// CH4 
			else if(com1_rx_data == '6') ad_start(5);// CH5 
			else if(com1_rx_data == '7') ad_start(6);// CH6 
			else if(com1_rx_data == '8') ad_start(7);// CH7 
			else putchar(com1_rx_data);		// ݼ
			// A/D  ǥ
			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("STAT ADC ");
			com1_rx_eflg = 0;
		}
		if(adc_int_flg){				// ADC  Ϸ ͷƮ ÷
			printf("CH%d > %d\r\n",adc_int_ch,adc_int_data);// ADC CH  ǥ
			adc_int_flg = 0;
		}
	}

// ADC initialization 
	ADMUX = 0x00;
	ADCSRA = 0x00;
	SFIOR &= 0xEF;

	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: unsigned char adc_input
// ITEM1 : AD CH(0-7)
// []: A/D 10bit
// ----------------------------------------------------------------------------
void ad_start(unsigned char adc_input)
{
	adc_int_ch = adc_input;					// ADC CH 
	ADMUX = adc_input;					// ADREF(0) + CH
	ADCSRA |= 0x40;						// AD conversion 
}

// ================================ EEPROM TEST ===============================
// [μ]: void
// ----------------------------------------------------------------------------
void eeprom_test(void)
{
char ch,buff[100],buff1[30],buff2[30],buff3[30];
unsigned char uch;
int i,j,cnt,exit_flg = 0;
unsigned int saddr,ecnt;

	printf("============== INTERNAL EEPROM TEST =============\r\n");
	printf("- 0 : TOP menu                                   \r\n");
	printf("  1 : Read  Data(000-fffh)                       \r\n");
	printf("  2 : Write Data(000-fffh)                       \r\n");
	printf("-------------------------------------------------\r\n");

	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1'){
				i = j = cnt = 0;
				printf("\r\nREAD(###(Add),***(Count)) > ");
				urx_string(buff);
				ch = buff[i++];			//  ˻ ڷ 
				while(ch != 0x0){
					if((ch == ':') || (ch == ',') || (ch == ' ')){
						j = 0;
						cnt++;
					}
					else{
						if(cnt == 0){
							buff1[j++] = ch;
							buff1[j] = 0x0;
						}
						else if(cnt == 1){
				    			buff2[j++] = ch;
				    			buff2[j] = 0x0;
						}
			    		}
				    	ch = buff[i++];
				}
				if(cnt == 1){			// ˻ 
					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
					ecnt = (unsigned int)atoh(buff2);// ī ȯ(HEX)
					printf("%04X > ",saddr);// ּ ǥ
					cnt = 0;
			   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ
						uch = EEPROM_read(saddr);//  
						printf("%02X ",uch);// Ÿ ǥ
						cnt++;
						if(cnt == 16){// 1 ǥ
							cnt = 0;
							if(i+1 <= ecnt) printf("\r\n%04X > ",saddr+1);// ּ ǥ
						}
				    	}
					printf("\r\nRead OK\r\n");
				}
			}
			else if(com1_rx_data == '2'){
				i = j = cnt = 0;
				printf("\r\nWRITE(###(Addr),***(Count),**(Data)) > ");
				urx_string(buff);
				ch = buff[i++];			//  ˻ ڷ 
				while(ch != 0x0){
					if((ch == ':') || (ch == ',') || (ch == ' ')){
						j = 0;
						cnt++;
					}
					else{
						if(cnt == 0){
							buff1[j++] = ch;
							buff1[j] = 0x0;
						}
						else if(cnt == 1){
							buff2[j++] = ch;
							buff2[j] = 0x0;
						}
						else if(cnt == 2){
							buff3[j++] = ch;
							buff3[j] = 0x0;
						}
					}
					ch = buff[i++];
				}
				if(cnt == 2){			// ˻ 
					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
					ecnt = (unsigned int)atoh(buff2);// ī ּ ȯ(HEX)
					uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
					for(i = 0; i <= ecnt; i++,saddr++) EEPROM_write(saddr,uch);//  
					printf("SRAM Data Write OK\r\n");
				}
			}
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
	}
	main_menu_disp();					//  ޴ ǥ
}

// ============================== EEPROM DATA READ ============================
// [μ] int addr
// Item1:  ּ(0 - 4095)
// []  (00 - ff)
// ----------------------------------------------------------------------------
unsigned char EEPROM_read(int addr)
{
unsigned char ch;

	while(EECR & 0x02);					//   Ϸñ 
	EEAR = addr;
	EECR |= 0x01;
	ch = EEDR;
	return(ch);
}

// ================================= EEPROM DATA  =========================
// [μ] int addr,unsigned char data
// Item1:  ּ(0 - 4095)
// Item2:  (00 - ff)
// ----------------------------------------------------------------------------
void EEPROM_write(int addr,unsigned char data)
{
	while(EECR & 0x02);					//   Ϸñ 
	EEAR = addr;
	EEDR = data;
	EECR |= 0x04;
	EECR |= 0x02;
}

// ============================== SRAM ׽Ʈ α׷ ========================
// [μ] void
// ---------------------------------------------------------------------------
void sram_test(void)
{
char ch,buff[100],buff1[30],buff2[30],buff3[30];
unsigned char uch;
int i,j,cnt,exit_flg = 0;
unsigned int saddr,ecnt;
unsigned char *sram_base = (unsigned char*)0x0;

	printf("============ SRAM TEST ============\r\n");
	printf("- 0 : TOP MENU                    -\r\n");
	printf("- 1 : Read  Data(0000-ffffh)      -\r\n");
	printf("- 2 : Write Data(0000-ffffh)      -\r\n");
	printf("-----------------------------------\r\n");
// External SRAM page configuration:
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): None
	MCUCR=0x80;
	XMCRA=0x00;

	com1_rx_eflg = 0;
	while(exit_flg == 0){
	    if(com1_rx_eflg == 1){
			com1_rx_eflg = 0;
			switch(com1_rx_data){
			    case   '0': exit_flg = 1; break;
			    case   '1': i = j = cnt = 0;
					printf("\r\nREAD(#####(A),***(C)) > ");
					urx_string(buff);
					ch = buff[i++];		//  ˻ ڷ 
					while(ch != 0x0){
				    		if((ch == ':') || (ch == ',') || (ch == ' ')){
							j = 0;
							cnt++;
						}
						else{
							if(cnt == 0){
					    			buff1[j++] = ch;
								buff1[j] = 0x0;
							}
							else if(cnt == 1){
					    			buff2[j++] = ch;
					    			buff2[j] = 0x0;
							}
				    		}
					    		ch = buff[i++];
					}
					if(cnt == 1){		// ˻ 
						saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
						ecnt = (unsigned int)atoh(buff2);// ī ȯ(HEX)
						printf("%04X > ",saddr);// ּ ǥ
						cnt = 0;
				   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ
							uch = sram_base[saddr];//  
							printf("%02X ",uch);// Ÿ ǥ
							cnt++;
							if(cnt == 16){// 1 ǥ
								cnt = 0;
								if(i+1 <= ecnt) printf("\r\n%04X > ",saddr+1);// ּ ǥ
							}
					    	}
						printf("\r\nRead OK\r\n");
					}
					break;
			    case  '2' : i = j = cnt = 0;
					printf("\r\nWRITE(#####(A),***(C),**(D)) > ");
					urx_string(buff);
					ch = buff[i++];		//  ˻ ڷ 
					while(ch != 0x0){
						if((ch == ':') || (ch == ',') || (ch == ' ')){
							j = 0;
							cnt++;
						}
						else{
							if(cnt == 0){
								buff1[j++] = ch;
								buff1[j] = 0x0;
							}
							else if(cnt == 1){
								buff2[j++] = ch;
								buff2[j] = 0x0;
							}
							else if(cnt == 2){
								buff3[j++] = ch;
								buff3[j] = 0x0;
							}
						}
							    ch = buff[i++];
					}
					if(cnt == 2){		// ˻ 
						saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
						ecnt = (unsigned int)atoh(buff2);// ī ּ ȯ(HEX)
						uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
						for(i = 0; i <= ecnt; i++,saddr++){
							sram_base[saddr] = uch;//  
						}
//						for(i = 0; i < ecnt; i++) sram_base[saddr+i] = uch;//  
						printf("SRAM Data Write OK\r\n");
					}
					break;
		    	    default   : break;
			}
		}
	}
	com1_rx_eflg = 0;
	main_menu_disp();					// ޴ ǥ

	MCUCR=0x00;						// clear exram config
	XMCRA=0x00;
}

// ==================================== COM2 TEST =============================
// [μ] void
// ----------------------------------------------------------------------------
void com2_test(void)
{
int exit_flg = 0;

	printf("============== COM2 LOOPBACK TEST ==============\r\n");
	printf("- 0  : RETURN TOP MENU                          \r\n");
	printf("------------------------------------------------\r\n");

	com1_rx_eflg = com2_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;
			else putchar1(com1_rx_data);		// COM2 send
			com1_rx_eflg = 0;
		}
		if(com2_rx_eflg){				// COM2  ˻
			putchar(com2_rx_data);			// COM1 send
			com2_rx_eflg = 0;
		}
	}
	main_menu_disp();					// ޴ ǥ
}

// ============================ COM2 1Ʈ ۽ ===========================
// [μ] char c
// Item1  ۽ 
// ----------------------------------------------------------------------------
void putchar1(char c)
{
	while((UCSR1A & DATA_REGISTER_EMPTY)==0);
	UDR1 = c;
}

// ============================ κ ڿ  ====================
// [μ] char buff[]
// Item1   Ÿ  (ִ 30)
// ----------------------------------------------------------------------------
void urx_string(char buff[])
{
char ch;
int exit_flg = 0,scnt = 0;

	com1_rx_eflg = 0;
	buff[0] = 0x0;						//  ũ
	while(exit_flg == 0){
	    while(com1_rx_eflg == 0); com1_rx_eflg = 0;		// 1 
	    ch = com1_rx_data;					//  Ÿ ε
	    ch = toupper(ch);					//  ȯ
	    if(ch == 0x08){					// BSŰ м
			if(scnt == 0) putchar(0x07);		//  溸 ۽
			else{					// 1ڸ 
			    putchar(0x08);
			    putchar(' ');
			    putchar(0x08);
			    scnt--;
			}
	    }
	    else if(ch == 0x0d){
			exit_flg = 1;				// Ż  ON
			buff[scnt] = 0x0;
			printf("\r\n");
	    }
	    else{
			buff[scnt++] = ch;			// ڷ 
			putchar(ch);
			if(scnt >= 30){ 			//   ʰ 
			    scnt = 29;
			    putchar(0x08);
			    putchar(0x07);
			}
	    }
	}
}

// ========================== ASCII͸ HEXͷ ȯ ==================
// [μ] unsigned char buff[]
// Item1  ȯ 
// [] 0 - 7fffffffh
// ----------------------------------------------------------------------------
long atoh(char buff[])
{
char ch;
int i = 0;
long data = 0;

	ch = buff[i++]; 					//  ε
	ch = toupper(ch);					// 빮 ȯ
	while(ch != 0){
		ch = ch - '0';              			// 0 - 9 ȯ
		if(ch > 9) ch = ch - 7;				// A - F ȯ
		if(ch < 0 || ch > 0x0f) ch = 0;			//  ˻
		else ch = ch & 0x0f;
		data = data << 4;				// ȯ  
		data |= ch;
		ch = buff[i++];					//  ε
		ch = toupper(ch);				// 빮 ȯ
	}
	return(data);
}
