
;CodeVisionAVR C Compiler V1.25.3 Standard
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega128
;Program type           : Application
;Clock frequency        : 16.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "test.vec"
	.INCLUDE "test.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

	OUT  RAMPZ,R24

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x500
;       1 // ============================ Atmega128 CPU ׽Ʈ α׷ =================
;       2 //  CPU : ATmega128-16M
;       3 //     ¥ : 2006-
;       4 //      : Ver1.0
;       5 //    : www.cpuplaza.com
;       6 // Ϸ : CodeVisionAVR
;       7 //      : serial 19200,N,8,1
;       8 // ----------------------------------------------------------------------------
;       9 // ⺻ 
;      10 #include <mega128.h>						// CPU  
;      11 
;      12 #include <stdio.h>
;      13 #include <stdlib.h>
;      14 #include <ctype.h>
;      15 #include <float.h>
;      16 #include <math.h>
;      17 
;      18 //  
;      19 #include "cpusetup.inc"						// cpu  ͷƮ  ƾ
;      20 // =================================== CPUʱȭ ͷƮ ===================
;      21 //      : CPU  ϰ ͷƮ  ƾ .
;      22 // ----------------------------------------------------------------------------
;      23 //   
;      24 #define RXB8 1
;      25 #define TXB8 0
;      26 #define UPE 2
;      27 #define OVR 3
;      28 #define FE 4
;      29 #define UDRE 5
;      30 #define RXC 7
;      31 
;      32 #define FRAMING_ERROR (1<<FE)
;      33 #define PARITY_ERROR (1<<UPE)
;      34 #define DATA_OVERRUN (1<<OVR)
;      35 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      36 #define RX_COMPLETE (1<<RXC)
;      37 
;      38 //  
;      39 char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
;      40 char com2_rx_data,com2_rx_eflg = 0;				// COM2   ͷƮ  /÷
;      41 
;      42 int timer0_cnt = 0;						// Ÿ̸0 ͷƮ  ī
;      43 int timer1_cnt = 0;						// Ÿ̸1 ͷƮ  ī
;      44 int timer2_cnt = 0;						// Ÿ̸2 ͷƮ  ī
;      45 int timer3_cnt = 0;						// Ÿ̸3 ͷƮ  ī
_timer3_cnt:
	.BYTE 0x2
;      46 
;      47 int exint0_flg = 0;						// EXINT0 ͷƮ  ÷
_exint0_flg:
	.BYTE 0x2
;      48 int exint1_flg = 0;						// EXINT1 ͷƮ  ÷
_exint1_flg:
	.BYTE 0x2
;      49 int exint2_flg = 0;						// EXINT2 ͷƮ  ÷
_exint2_flg:
	.BYTE 0x2
;      50 int exint3_flg = 0;						// EXINT3 ͷƮ  ÷
_exint3_flg:
	.BYTE 0x2
;      51 int exint4_flg = 0;						// EXINT4 ͷƮ  ÷
_exint4_flg:
	.BYTE 0x2
;      52 int exint5_flg = 0;						// EXINT5 ͷƮ  ÷
_exint5_flg:
	.BYTE 0x2
;      53 int exint6_flg = 0;						// EXINT6 ͷƮ  ÷
_exint6_flg:
	.BYTE 0x2
;      54 int exint7_flg = 0;						// EXINT7 ͷƮ  ÷
_exint7_flg:
	.BYTE 0x2
;      55 
;      56 unsigned int adc_int_data = 0;					// ADC ͷƮ  
_adc_int_data:
	.BYTE 0x2
;      57 int adc_int_ch = 0;						// ADC CH ͷƮ 
_adc_int_ch:
	.BYTE 0x2
;      58 int adc_int_flg = 0;						// ADC ͷƮ  ÷
_adc_int_flg:
	.BYTE 0x2
;      59 
;      60 // ===================================== CPUʱȭ ============================
;      61 // [μ] void
;      62 // ----------------------------------------------------------------------------
;      63 void cpu_setup(void)
;      64 {

	.CSEG
_cpu_setup:
;      65 
;      66 // PortA 
;      67 	PORTA=0x00;						// Ʈ  reg
	CALL SUBOPT_0x0
;      68 	DDRA=0x00;						// Ʈ  reg(0Է,1)
;      69 // PortB 
;      70 	PORTB=0x00;						// Ʈ  reg
;      71 	DDRB=0x00;						// Ʈ  reg(0Է,1)
;      72 
;      73 // PortC 
;      74 	PORTC=0x00;						// Ʈ  reg
;      75 	DDRC=0x00;                                              // Ʈ  reg(0Է,1)
;      76 
;      77 // PortD 
;      78 	PORTD=0x00;						// Ʈ  reg
;      79 	DDRD=0x00;                                              // Ʈ  reg(0Է,1)
;      80 
;      81 // PortE 
;      82 	PORTE=0x00;						// Ʈ  reg
;      83 	DDRE=0x00;                                              // Ʈ  reg(0Է,1)
;      84 // PortF 
;      85 	PORTF=0x00;						// Ʈ  reg
;      86 	DDRF=0x00;                                              // Ʈ  reg(0Է,1)
;      87 // PortG 
;      88 	PORTG=0x00;						// Ʈ  reg
;      89 	DDRG=0x00;                                              // Ʈ  reg(0Է,1)
;      90 
;      91 // Timer/Counter0 
;      92 	ASSR=0x00;
	CALL SUBOPT_0x1
;      93 	TCCR0=0x00;
;      94 	TCNT0=0x00;
;      95 	OCR0=0x00;
;      96 
;      97 // Timer/Counter1 
;      98 	TCCR1A=0x00;
	CALL SUBOPT_0x2
;      99 	TCCR1B=0x00;
;     100 	TCNT1H=0x00;
;     101 	TCNT1L=0x00;
;     102 	OCR1AH=0x00;
;     103 	OCR1AL=0x00;
;     104 	OCR1BH=0x00;
;     105 	OCR1BL=0x00;
;     106 	OCR1CH=0x00;
;     107 	OCR1CL=0x00;
;     108 
;     109 // Timer/Counter2 
;     110 	TCCR2=0x00;
	CALL SUBOPT_0x3
;     111 	TCNT2=0x00;
;     112 	OCR2=0x00;
;     113 
;     114 // Timer/Counter3 
;     115 	TCCR3A=0x00;
	CALL SUBOPT_0x4
;     116 	TCCR3B=0x00;
;     117 	TCNT3H=0x00;
;     118 	TCNT3L=0x00;
;     119 	OCR3AH=0x00;
;     120 	OCR3AL=0x00;
;     121 	OCR3BH=0x00;
;     122 	OCR3BL=0x00;
;     123 	OCR3CH=0x00;
;     124 	OCR3CL=0x00;
;     125 
;     126 // External Interrupt(s) 
;     127 // INT0: Off
;     128 // INT1: Off
;     129 // INT2: Off
;     130 // INT3: Off
;     131 // INT4: Off
;     132 // INT5: Off
;     133 // INT6: Off
;     134 // INT7: Off
;     135 	EICRA=0x00;
	CALL SUBOPT_0x5
;     136 	EICRB=0x00;
;     137 	EIMSK=0x00;
;     138 
;     139 // Timer(s)/Counter(s) Interrupt(s) 
;     140 	TIMSK=0x00;
	OUT  0x37,R30
;     141 	ETIMSK=0x00;
	LDI  R30,LOW(0)
	STS  125,R30
;     142 
;     143 //  ʱȭ(COM1)
;     144 // 19200Bps, 8Data, 1 Stop, No Parity
;     145 	UCSR0A=0x00;
	OUT  0xB,R30
;     146 	UCSR0B=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;     147 	UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  149,R30
;     148 	UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  144,R30
;     149 	UBRR0L=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
;     150 
;     151 //  ʱȭ(COM2)
;     152 // 19200Bps, 8Data, 1 Stop, No Parity
;     153 	UCSR1A=0x00;
	LDI  R30,LOW(0)
	STS  155,R30
;     154 	UCSR1B=0x98;
	LDI  R30,LOW(152)
	STS  154,R30
;     155 	UCSR1C=0x06;
	LDI  R30,LOW(6)
	STS  157,R30
;     156 	UBRR1H=0x00;
	LDI  R30,LOW(0)
	STS  152,R30
;     157 	UBRR1L=0x33;
	LDI  R30,LOW(51)
	STS  153,R30
;     158 
;     159 // External SRAM page configuration:
;     160 //              -              / 0000h - FFFFh
;     161 // Lower page wait state(s): None
;     162 // Upper page wait state(s): None
;     163 //	MCUCR=0x80;
;     164 //	XMCRA=0x00;
;     165 
;     166 // Analog Comparator 
;     167 	ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     168 	SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     169 
;     170 // Global enable interrupts
;     171 #asm("sei")
	sei
;     172 }
	RET
;     173 
;     174 // =============================== COM1 ͷƮ ===========================
;     175 // [μ] void
;     176 // ----------------------------------------------------------------------------
;     177 #pragma savereg-
;     178 interrupt [USART0_RXC] void uart0_rx_isr(void)
;     179 {
_uart0_rx_isr:
;     180 char status,data;
;     181 #asm
;     182 	push r26
	push r26
;     183 	push r27
	push r27
;     184 	push r30
	push r30
;     185 	push r31
	push r31
;     186 	in   r26,sreg
	in   r26,sreg
;     187 	push r26
	push r26
;     188 #endasm
;     189 
;     190 	status=UCSR0A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
;     191 	data=UDR0;
	IN   R16,12
;     192 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
;     193 		com1_rx_data = data;
	MOV  R5,R16
;     194 		com1_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     195 	}
;     196 
;     197 #asm
_0x3:
;     198 	pop  r26
	pop  r26
;     199 	out  sreg,r26
	out  sreg,r26
;     200 	pop  r31
	pop  r31
;     201 	pop  r30
	pop  r30
;     202 	pop  r27
	pop  r27
;     203 	pop  r26
	pop  r26
;     204 #endasm
;     205 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     206 #pragma savereg+
;     207 
;     208 
;     209 // ============================== COM2  ͷƮ ===========================
;     210 // [μ] void
;     211 // ----------------------------------------------------------------------------
;     212 #pragma savereg-
;     213 interrupt [USART1_RXC] void uart1_rx_isr(void)
;     214 {
_uart1_rx_isr:
;     215 char status,data;
;     216 #asm
;     217 	push r26
	push r26
;     218 	push r27
	push r27
;     219 	push r30
	push r30
;     220 	push r31
	push r31
;     221 	in   r26,sreg
	in   r26,sreg
;     222 	push r26
	push r26
;     223 #endasm
;     224 
;     225 	status=UCSR1A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	LDS  R17,155
;     226 	data=UDR1;
	LDS  R16,156
;     227 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x4
;     228 		com2_rx_data = data;
	MOV  R7,R16
;     229 		com2_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R6,R30
;     230 	}
;     231 
;     232 #asm
_0x4:
;     233 	pop  r26
	pop  r26
;     234 	out  sreg,r26
	out  sreg,r26
;     235 	pop  r31
	pop  r31
;     236 	pop  r30
	pop  r30
;     237 	pop  r27
	pop  r27
;     238 	pop  r26
	pop  r26
;     239 #endasm
;     240 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     241 #pragma savereg+
;     242 
;     243 // ========================== TIMER0 overflow ͷƮ ========================
;     244 // [μ] void
;     245 // [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
;     246 // ----------------------------------------------------------------------------
;     247 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     248 {
_timer0_ovf_isr:
	CALL SUBOPT_0x6
;     249 	TCNT0 = 99;						// 255-156 = 100
	LDI  R30,LOW(99)
	OUT  0x32,R30
;     250 	timer0_cnt++;						// Ÿ̸0 ī
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
;     251 }
	CALL SUBOPT_0x7
	RETI
;     252 
;     253 // ========================== TIMER1 overflow ͷƮ ========================
;     254 // [μ] void
;     255 // [] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
;     256 // ----------------------------------------------------------------------------
;     257 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;     258 {
_timer1_ovf_isr:
	CALL SUBOPT_0x6
;     259 	TCNT1 = 63035;						// 65535 - 2500 = 63035
	LDI  R30,LOW(63035)
	LDI  R31,HIGH(63035)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
;     260 	timer1_cnt++;						// Ÿ̸1 ī
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
;     261 }
	CALL SUBOPT_0x7
	RETI
;     262 
;     263 // ========================== TIMER2 overflow ͷƮ ========================
;     264 // [μ] void
;     265 // [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
;     266 // ----------------------------------------------------------------------------
;     267 interrupt [TIM2_OVF] void timer2_ovf_isr(void)
;     268 {
_timer2_ovf_isr:
	CALL SUBOPT_0x6
;     269 	TCNT2 = 99;						// 255-156 = 100
	LDI  R30,LOW(99)
	OUT  0x24,R30
;     270 	timer2_cnt++;						// Ÿ̸2 ī
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
;     271 }
	CALL SUBOPT_0x7
	RETI
;     272 
;     273 // ========================== TIMER3 overflow ͷƮ ========================
;     274 // [μ] void
;     275 // [] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
;     276 // ----------------------------------------------------------------------------
;     277 interrupt [TIM3_OVF] void timer3_ovf_isr(void)
;     278 {
_timer3_ovf_isr:
	CALL SUBOPT_0x6
;     279 	TCNT3H=0xf6;  						// 65535 - 2500 = 63035
	CALL SUBOPT_0x8
;     280 	TCNT3L=0x3b;
;     281 	timer3_cnt++;						// Ÿ̸3 ī
	LDS  R30,_timer3_cnt
	LDS  R31,_timer3_cnt+1
	ADIW R30,1
	STS  _timer3_cnt,R30
	STS  _timer3_cnt+1,R31
;     282 }
	CALL SUBOPT_0x7
	RETI
;     283 
;     284 // ========================== ܺ INT0 ͷƮ ==============================
;     285 // [μ] void
;     286 // ----------------------------------------------------------------------------
;     287 interrupt [EXT_INT0] void ext_int0_isr(void)
;     288 {
_ext_int0_isr:
	CALL SUBOPT_0x9
;     289 	exint0_flg = 1;						// EXINT0 ÷ ON
	STS  _exint0_flg,R30
	STS  _exint0_flg+1,R31
;     290 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     291 
;     292 // ========================== ܺ INT1 ͷƮ ==============================
;     293 // [μ] void
;     294 // ----------------------------------------------------------------------------
;     295 interrupt [EXT_INT1] void ext_int1_isr(void)
;     296 {
_ext_int1_isr:
	CALL SUBOPT_0x9
;     297 	exint1_flg = 1;						// EXINT1 ÷ ON
	STS  _exint1_flg,R30
	STS  _exint1_flg+1,R31
;     298 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     299 
;     300 // ========================== ܺ INT2 ͷƮ ==============================
;     301 // [μ] void
;     302 // ----------------------------------------------------------------------------
;     303 interrupt [EXT_INT2] void ext_int2_isr(void)
;     304 {
_ext_int2_isr:
	CALL SUBOPT_0x9
;     305 	exint2_flg = 1;						// EXINT2 ÷ ON
	STS  _exint2_flg,R30
	STS  _exint2_flg+1,R31
;     306 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     307 
;     308 // ========================== ܺ INT3 ͷƮ ==============================
;     309 // [μ] void
;     310 // ----------------------------------------------------------------------------
;     311 interrupt [EXT_INT3] void ext_int3_isr(void)
;     312 {
_ext_int3_isr:
	CALL SUBOPT_0x9
;     313 	exint3_flg = 1;						// EXINT3 ÷ ON
	STS  _exint3_flg,R30
	STS  _exint3_flg+1,R31
;     314 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     315 
;     316 // ========================== ܺ INT4 ͷƮ ==============================
;     317 // [μ] void
;     318 // ----------------------------------------------------------------------------
;     319 interrupt [EXT_INT4] void ext_int4_isr(void)
;     320 {
_ext_int4_isr:
	CALL SUBOPT_0x9
;     321 	exint4_flg = 1;						// EXINT4 ÷ ON
	STS  _exint4_flg,R30
	STS  _exint4_flg+1,R31
;     322 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     323 
;     324 // ========================== ܺ INT5 ͷƮ ==============================
;     325 // [μ] void
;     326 // ----------------------------------------------------------------------------
;     327 interrupt [EXT_INT5] void ext_int5_isr(void)
;     328 {
_ext_int5_isr:
	CALL SUBOPT_0x9
;     329 	exint5_flg = 1;						// EXINT5 ÷ ON
	STS  _exint5_flg,R30
	STS  _exint5_flg+1,R31
;     330 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     331 
;     332 // ========================== ܺ INT6 ͷƮ ==============================
;     333 // [μ] void
;     334 // ----------------------------------------------------------------------------
;     335 interrupt [EXT_INT6] void ext_int6_isr(void)
;     336 {
_ext_int6_isr:
	CALL SUBOPT_0x9
;     337 	exint6_flg = 1;						// EXINT6 ÷ ON
	STS  _exint6_flg,R30
	STS  _exint6_flg+1,R31
;     338 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     339 
;     340 // ========================== ܺ INT7 ͷƮ ==============================
;     341 // [μ] void
;     342 // ----------------------------------------------------------------------------
;     343 interrupt [EXT_INT7] void ext_int7_isr(void)
;     344 {
_ext_int7_isr:
	CALL SUBOPT_0x9
;     345 	exint7_flg = 1;						// EXINT7 ÷ ON
	STS  _exint7_flg,R30
	STS  _exint7_flg+1,R31
;     346 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     347 
;     348 // =============================== ADC ͷƮ ===============================
;     349 // [μ] void
;     350 // ----------------------------------------------------------------------------
;     351 interrupt [ADC_INT] void adc_isr(void)
;     352 {
_adc_isr:
	ST   -Y,R30
	ST   -Y,R31
;     353 	adc_int_data = ADCW;					// ADC
	IN   R30,0x4
	IN   R31,0x4+1
	STS  _adc_int_data,R30
	STS  _adc_int_data+1,R31
;     354 	adc_int_flg = 1;					// ADC Ϸ ÷ 
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _adc_int_flg,R30
	STS  _adc_int_flg+1,R31
;     355 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     356 
;     357 // Լ 
;     358 void main_menu_disp(void);					//  ޴ ǥ
;     359 void cpu_ioport_output(void);					// CPU PORT I/O ׽Ʈ
;     360 void timer0_test(void);						// TIMER0 TEST
;     361 void timer1_test(void);						// TIMER1 TEST
;     362 void timer2_test(void);						// TIMER2 TEST
;     363 void timer3_test(void);						// TIMER3 TEST
;     364 void exint_test(void);						// EXINT0,1 TEST
;     365 
;     366 void ad_polling_test(void);					// A/D   TEST
;     367 unsigned int ad_read(unsigned char adc_input);			// A/D  ( )
;     368 void ad_interrupt_test(void);					// A/D ͷƮ  TEST
;     369 void ad_start(unsigned char adc_input);				// AD  (ͷƮ )
;     370 
;     371 void eeprom_test(void);						// EEPROM TEST
;     372 void EEPROM_write(int addr,unsigned char data);			// EEPROM  
;     373 unsigned char EEPROM_read(int addr);				// EEPROM  
;     374 
;     375 void sram_test(void);						// SRAM TEST
;     376 
;     377 void com2_test(void);						// COM2 TEST
;     378 void putchar1(char c);						// COM2 1Ʈ ۽
;     379 
;     380 void urx_string(char buff[]);					// Ʈ 
;     381 long atoh(char buff[]);						// ASCII TO HEX 
;     382 
;     383 //  
;     384 
;     385 // ===============================  α׷ ==============================
;     386 // [μ]: void
;     387 // ---------------------------------------------------------------------------
;     388 void main(void)
;     389 {
_main:
;     390 	cpu_setup();						// cpuʱȭ
	CALL _cpu_setup
;     391 	main_menu_disp();					//  ޴ ǥ
	RCALL _main_menu_disp
;     392 	while(1){						// Place your code here
_0x5:
;     393 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BREQ _0x8
;     394 			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
	LDI  R30,LOW(49)
	CP   R30,R5
	BRNE _0x9
	RCALL _cpu_ioport_output
;     395 			else if(com1_rx_data == '2') timer0_test(); // TIMER0 TEST
	RJMP _0xA
_0x9:
	LDI  R30,LOW(50)
	CP   R30,R5
	BRNE _0xB
	RCALL _timer0_test
;     396 			else if(com1_rx_data == '3') timer1_test(); // TIMER1 TEST
	RJMP _0xC
_0xB:
	LDI  R30,LOW(51)
	CP   R30,R5
	BRNE _0xD
	RCALL _timer1_test
;     397 			else if(com1_rx_data == '4') timer2_test(); // TIMER2 TEST
	RJMP _0xE
_0xD:
	LDI  R30,LOW(52)
	CP   R30,R5
	BRNE _0xF
	RCALL _timer2_test
;     398 			else if(com1_rx_data == '5') timer3_test(); // TIMER3 TEST
	RJMP _0x10
_0xF:
	LDI  R30,LOW(53)
	CP   R30,R5
	BRNE _0x11
	RCALL _timer3_test
;     399 			else if(com1_rx_data == '6') exint_test();  // EXINT0,1 TEST
	RJMP _0x12
_0x11:
	LDI  R30,LOW(54)
	CP   R30,R5
	BRNE _0x13
	RCALL _exint_test
;     400 			else if(com1_rx_data == '7') ad_polling_test();// A/D POLLING TEST
	RJMP _0x14
_0x13:
	LDI  R30,LOW(55)
	CP   R30,R5
	BRNE _0x15
	RCALL _ad_polling_test
;     401 			else if(com1_rx_data == '8') ad_interrupt_test(); // A/D POLLING TEST
	RJMP _0x16
_0x15:
	LDI  R30,LOW(56)
	CP   R30,R5
	BRNE _0x17
	RCALL _ad_interrupt_test
;     402 			else if(com1_rx_data == '9') eeprom_test(); // EEPROM TEST
	RJMP _0x18
_0x17:
	LDI  R30,LOW(57)
	CP   R30,R5
	BRNE _0x19
	RCALL _eeprom_test
;     403 			else if(com1_rx_data == 'a') sram_test();// SRAM TEST
	RJMP _0x1A
_0x19:
	LDI  R30,LOW(97)
	CP   R30,R5
	BRNE _0x1B
	RCALL _sram_test
;     404 			else if(com1_rx_data == 'b') com2_test();// COM2 TEST
	RJMP _0x1C
_0x1B:
	LDI  R30,LOW(98)
	CP   R30,R5
	BRNE _0x1D
	RCALL _com2_test
;     405 			else putchar(com1_rx_data);
	RJMP _0x1E
_0x1D:
	ST   -Y,R5
	CALL _putchar
;     406 			com1_rx_eflg = 0;
_0x1E:
_0x1C:
_0x1A:
_0x18:
_0x16:
_0x14:
_0x12:
_0x10:
_0xE:
_0xC:
_0xA:
	CLR  R4
;     407 		}
;     408 	}
_0x8:
	RJMP _0x5
;     409 }
_0x1F:
	RJMP _0x1F
;     410 
;     411 // =====================================  ޴ ǥ =======================
;     412 // [μ]: void
;     413 // ---------------------------------------------------------------------------
;     414 void main_menu_disp(void)
;     415 {
_main_menu_disp:
;     416 	printf("\r\n");
	CALL SUBOPT_0xA
;     417 	printf("=================== MAIN MENU ==================\r\n");
	__POINTW1FN _0,3
	CALL SUBOPT_0xB
;     418 	printf("- 1  : CPU I/O PORT TEST                        \r\n");
	__POINTW1FN _0,54
	CALL SUBOPT_0xB
;     419 	printf("- 2  : TIMER0 TEST                              \r\n");
	__POINTW1FN _0,105
	CALL SUBOPT_0xB
;     420 	printf("- 3  : TIMER1 TEST                              \r\n");
	__POINTW1FN _0,156
	CALL SUBOPT_0xB
;     421 	printf("- 4  : TIMER2 TEST                              \r\n");
	__POINTW1FN _0,207
	CALL SUBOPT_0xB
;     422 	printf("- 5  : TIMER3 TEST                              \r\n");
	__POINTW1FN _0,258
	CALL SUBOPT_0xB
;     423 	printf("- 6  : EXINT0,1,2,3,4,5,6,7 TEST                \r\n");
	__POINTW1FN _0,309
	CALL SUBOPT_0xB
;     424 	printf("- 7  : A/D POLLING   TEST                       \r\n");
	__POINTW1FN _0,360
	CALL SUBOPT_0xB
;     425 	printf("- 8  : A/D INTERRUPT TEST                       \r\n");
	__POINTW1FN _0,411
	CALL SUBOPT_0xB
;     426 	printf("- 9  : EEPROM TEST                              \r\n");
	__POINTW1FN _0,462
	CALL SUBOPT_0xB
;     427 	printf("- a  : SRAM   TEST                              \r\n");
	__POINTW1FN _0,513
	CALL SUBOPT_0xB
;     428 	printf("- b  : COM2   TEST                              \r\n");
	__POINTW1FN _0,564
	CALL SUBOPT_0xB
;     429 	printf("----------------- CPUPLAZA ---------------------\r\n");
	__POINTW1FN _0,615
	CALL SUBOPT_0xB
;     430 }
	RET
;     431 
;     432 // ============================== CPU_IO TEST =================================
;     433 // [μ]: void
;     434 // ----------------------------------------------------------------------------
;     435 void cpu_ioport_output(void)
;     436 {
_cpu_ioport_output:
;     437 int out_cnt,exit_flg = 0;
;     438 
;     439 	printf("================ CPU I/O PORT TEST ==============\r\n");
	CALL SUBOPT_0xC
;	out_cnt -> R16,R17
;	exit_flg -> R18,R19
	__POINTW1FN _0,666
	CALL SUBOPT_0xB
;     440 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xD
;     441 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xE
;     442 // CPU PORT   
;     443 // PORTA[0..7] : OUT
;     444 	PORTA=0xff;						// Ʈ  reg
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     445 	DDRA=0xff;						// Ʈ  reg(0Է,1)
	OUT  0x1A,R30
;     446 // CPU PORT   
;     447 // PORTB[0..7] : OUT
;     448 	PORTB=0xff;						// Ʈ  reg
	OUT  0x18,R30
;     449 	DDRB=0xff;						// Ʈ  reg(0Է,1)
	OUT  0x17,R30
;     450 // PORTC[0..5] : OUT
;     451 	PORTC=0xff;						// Ʈ  reg
	OUT  0x15,R30
;     452 	DDRC=0xff;						// Ʈ  reg(0Է,1)
	OUT  0x14,R30
;     453 // PORTD[0..7] : OUT
;     454 	PORTD=0xff;						// Ʈ  reg
	OUT  0x12,R30
;     455 	DDRD=0xff;						// Ʈ  reg(0Է,1)
	OUT  0x11,R30
;     456 // PORTE[2..7] : OUT
;     457 	PORTE=0xfc;						// Ʈ  reg
	LDI  R30,LOW(252)
	OUT  0x3,R30
;     458 	DDRE=0xfc;						// Ʈ  reg(0Է,1)
	OUT  0x2,R30
;     459 // PORTF[0..7] : OUT
;     460 	PORTF=0xff;						// Ʈ  reg
	LDI  R30,LOW(255)
	STS  98,R30
;     461 	DDRF=0xff;						// Ʈ  reg(0Է,1)
	STS  97,R30
;     462 // PORTG[0..2] : OUT
;     463 	PORTG=0x07;						// Ʈ  reg
	LDI  R30,LOW(7)
	STS  101,R30
;     464 	DDRG=0x07;						// Ʈ  reg(0Է,1)
	STS  100,R30
;     465 
;     466 // LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
;     467 // Timer/Counter0 (Overflow)
;     468 	ASSR=0x00;
	CALL SUBOPT_0xF
;     469 	TCCR0 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
;     470 	TCNT0 = 99;						// 255-156 = 99
;     471 	OCR0=0x00;
;     472 	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
;     473 
;     474 	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
;     475 	out_cnt = 0;
	__GETWRN 16,17,0
;     476 	com1_rx_eflg = 0;
	CLR  R4
;     477 	while(exit_flg == 0){
_0x20:
	MOV  R0,R18
	OR   R0,R19
	BREQ PC+3
	JMP _0x22
;     478 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BREQ _0x23
;     479 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x24
	__GETWRN 18,19,1
;     480 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x25
_0x24:
	ST   -Y,R5
	CALL _putchar
;     481 			com1_rx_eflg = 0;
_0x25:
	CLR  R4
;     482 		}
;     483 		if(timer0_cnt >= 50){				// 500ms  
_0x23:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CP   R8,R30
	CPC  R9,R31
	BRGE PC+3
	JMP _0x26
;     484 			if(out_cnt >= 0 && out_cnt < 8) PORTA = ~(1 << out_cnt);// PORTA (ش Ʈ 0)
	SUBI R16,0
	SBCI R17,0
	BRLT _0x28
	__CPWRN 16,17,8
	BRLT _0x29
_0x28:
	RJMP _0x27
_0x29:
	MOVW R30,R16
	CALL SUBOPT_0x10
	OUT  0x1B,R30
;     485 			else if(out_cnt >= 8 && out_cnt < 16){	// PORTB 
	RJMP _0x2A
_0x27:
	__CPWRN 16,17,8
	BRLT _0x2C
	__CPWRN 16,17,16
	BRLT _0x2D
_0x2C:
	RJMP _0x2B
_0x2D:
;     486 				if(out_cnt == 8) PORTA = 0xff;	// PORTA CLEAR
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x2E
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     487 				PORTB = ~(1 << (out_cnt-8));	// PORTB (ش Ʈ 0)
_0x2E:
	MOVW R30,R16
	SBIW R30,8
	CALL SUBOPT_0x10
	OUT  0x18,R30
;     488 			}
;     489 			else if(out_cnt >= 16 && out_cnt < 24){	// PORT C 
	RJMP _0x2F
_0x2B:
	__CPWRN 16,17,16
	BRLT _0x31
	__CPWRN 16,17,24
	BRLT _0x32
_0x31:
	RJMP _0x30
_0x32:
;     490 				if(out_cnt == 16) PORTB = 0xff;	// PORTB CLEAR
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x33
	LDI  R30,LOW(255)
	OUT  0x18,R30
;     491 				PORTC = ~(1 << (out_cnt-16));	// PORTC (ش Ʈ 0)
_0x33:
	MOVW R30,R16
	SBIW R30,16
	CALL SUBOPT_0x10
	OUT  0x15,R30
;     492 			}
;     493 			else if(out_cnt >= 24 && out_cnt < 32){	// PORTD 
	RJMP _0x34
_0x30:
	__CPWRN 16,17,24
	BRLT _0x36
	__CPWRN 16,17,32
	BRLT _0x37
_0x36:
	RJMP _0x35
_0x37:
;     494 				if(out_cnt == 24) PORTC = 0xff;	// PORTC CLEAR
	LDI  R30,LOW(24)
	LDI  R31,HIGH(24)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x38
	LDI  R30,LOW(255)
	OUT  0x15,R30
;     495 				PORTD = ~(1 << (out_cnt-24));	// PORTD (ش Ʈ 0)
_0x38:
	MOVW R30,R16
	SBIW R30,24
	CALL SUBOPT_0x10
	OUT  0x12,R30
;     496 			}
;     497 			else if(out_cnt >= 32 && out_cnt < 38){	// PORTE 
	RJMP _0x39
_0x35:
	__CPWRN 16,17,32
	BRLT _0x3B
	__CPWRN 16,17,38
	BRLT _0x3C
_0x3B:
	RJMP _0x3A
_0x3C:
;     498 				if(out_cnt == 32) PORTD = 0xff;	// PORTD CLEAR
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x3D
	LDI  R30,LOW(255)
	OUT  0x12,R30
;     499 				PORTE = ~(4 << (out_cnt-32));	// PORTE (ش Ʈ 0)
_0x3D:
	MOVW R30,R16
	SBIW R30,32
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	CALL __LSLW12
	COM  R30
	COM  R31
	OUT  0x3,R30
;     500 			}
;     501 			else if(out_cnt >= 38 && out_cnt < 46){	// PORTF 
	RJMP _0x3E
_0x3A:
	__CPWRN 16,17,38
	BRLT _0x40
	__CPWRN 16,17,46
	BRLT _0x41
_0x40:
	RJMP _0x3F
_0x41:
;     502 				if(out_cnt == 38) PORTE = 0xfc;	// PORTE CLEAR
	LDI  R30,LOW(38)
	LDI  R31,HIGH(38)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x42
	LDI  R30,LOW(252)
	OUT  0x3,R30
;     503 				PORTF = ~(1 << (out_cnt-38));	// PORTF (ش Ʈ 0)
_0x42:
	MOVW R30,R16
	SBIW R30,38
	CALL SUBOPT_0x10
	STS  98,R30
;     504 			}
;     505 			else if(out_cnt >= 46 && out_cnt < 49){	// PORTG 
	RJMP _0x43
_0x3F:
	__CPWRN 16,17,46
	BRLT _0x45
	__CPWRN 16,17,49
	BRLT _0x46
_0x45:
	RJMP _0x44
_0x46:
;     506 				if(out_cnt == 46) PORTF = 0xff;	// PORTF CLEAR
	LDI  R30,LOW(46)
	LDI  R31,HIGH(46)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x47
	LDI  R30,LOW(255)
	STS  98,R30
;     507 				PORTG = ~(1 << (out_cnt-46));	// PORTG (ش Ʈ 0)
_0x47:
	MOVW R30,R16
	SBIW R30,46
	CALL SUBOPT_0x10
	STS  101,R30
;     508 			}
;     509 			out_cnt++;				//  ġ ī 
_0x44:
_0x43:
_0x3E:
_0x39:
_0x34:
_0x2F:
_0x2A:
	__ADDWRN 16,17,1
;     510 			if(out_cnt >= 50) out_cnt = 0;		//  ġ ʰ ˻
	__CPWRN 16,17,50
	BRLT _0x48
	__GETWRN 16,17,0
;     511 			if(out_cnt == 0){			//  ü ʱȭ
_0x48:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x49
;     512 				PORTA = 0xff;
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     513 				PORTB = 0xff;
	OUT  0x18,R30
;     514 				PORTC = 0xff;
	OUT  0x15,R30
;     515 				PORTD = 0xff;
	OUT  0x12,R30
;     516 				PORTE = 0xfc;
	LDI  R30,LOW(252)
	OUT  0x3,R30
;     517 				PORTF = 0xff;
	LDI  R30,LOW(255)
	STS  98,R30
;     518 				PORTG = 0x07;
	LDI  R30,LOW(7)
	STS  101,R30
;     519 			}
;     520 			timer0_cnt = 0;
_0x49:
	CLR  R8
	CLR  R9
;     521 		}
;     522 	}
_0x26:
	RJMP _0x20
_0x22:
;     523 
;     524 // Timer/Counter0 
;     525 	ASSR = 0x00;
	CALL SUBOPT_0x1
;     526 	TCCR0 = 0x00;
;     527 	TCNT0 = 0;
;     528 	OCR0=0x00;
;     529 	TIMSK &= 0xfe;						// TIMER0 ͷƮ 
	IN   R30,0x37
	ANDI R30,0xFE
	OUT  0x37,R30
;     530 
;     531 // CPU PORT ʱⰪ  
;     532 // PORTA
;     533 	PORTA=0x00;						// Ʈ  reg
	CALL SUBOPT_0x0
;     534 	DDRA=0x00;						// Ʈ  reg(0Է,1)
;     535 // PORTB
;     536 	PORTB=0x00;						// Ʈ  reg
;     537 	DDRB=0x00;						// Ʈ  reg(0Է,1)
;     538 // PORTC
;     539 	PORTC=0x00;						// Ʈ  reg
;     540 	DDRC=0x00;						// Ʈ  reg(0Է,1)
;     541 // PORTD
;     542 	PORTD=0x00;						// Ʈ  reg
;     543 	DDRD=0x00;						// Ʈ  reg(0Է,1)
;     544 // PORTE
;     545 	PORTE=0x00;						// Ʈ  reg
;     546 	DDRE=0x00;						// Ʈ  reg(0Է,1)
;     547 // PORTF
;     548 	PORTF=0x00;						// Ʈ  reg
;     549 	DDRF=0x00;						// Ʈ  reg(0Է,1)
;     550 // PORTG
;     551 	PORTG=0x00;						// Ʈ  reg
;     552 	DDRG=0x00;						// Ʈ  reg(0Է,1)
;     553 
;     554 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     555 }
	RJMP _0x18B
;     556 
;     557 // ============================== TIMER0 TEST =================================
;     558 // [μ]: void
;     559 // ----------------------------------------------------------------------------
;     560 void timer0_test(void)
;     561 {
_timer0_test:
;     562 int exit_flg = 0;
;     563 
;     564 	printf("=================== TIMER0 TEST =================\r\n");
	CALL SUBOPT_0x11
;	exit_flg -> R16,R17
	__POINTW1FN _0,822
	CALL SUBOPT_0xB
;     565 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xD
;     566 	printf("- interrupt    : TIMER0 Overfow 9.9984ms         \r\n");
	__POINTW1FN _0,874
	CALL SUBOPT_0xB
;     567 	printf("- message disp : 9.9984ms * 100 = 999.84ms       \r\n");
	__POINTW1FN _0,926
	CALL SUBOPT_0xB
;     568 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xE
;     569 
;     570 // Timer/Counter0 (Overflow)
;     571 	ASSR=0x00;
	CALL SUBOPT_0xF
;     572 	TCCR0 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
;     573 	TCNT0 = 99;						// 255-156 = 99
;     574 	OCR0=0x00;
;     575 	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
;     576 
;     577 	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
;     578 	com1_rx_eflg = 0;
	CLR  R4
;     579 	while(exit_flg == 0){
_0x4A:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x4C
;     580 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BREQ _0x4D
;     581 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x4E
	__GETWRN 16,17,1
;     582 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x4F
_0x4E:
	ST   -Y,R5
	CALL _putchar
;     583 			com1_rx_eflg = 0;
_0x4F:
	CLR  R4
;     584 		}
;     585 		if(timer0_cnt >= 100){				// 999.84ms üũ
_0x4D:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R8,R30
	CPC  R9,R31
	BRLT _0x50
;     586 			printf("TIMER0 Overflow Interrupt\r\n");
	__POINTW1FN _0,978
	CALL SUBOPT_0xB
;     587 			timer0_cnt = 0;
	CLR  R8
	CLR  R9
;     588 		}
;     589 	}
_0x50:
	RJMP _0x4A
_0x4C:
;     590 
;     591 // Timer/Counter0 
;     592 	ASSR = 0x00;
	CALL SUBOPT_0x1
;     593 	TCCR0 = 0x00;
;     594 	TCNT0 = 0;
;     595 	OCR0=0x00;
;     596 	TIMSK &= 0xfe;						// TIMER0 ͷƮ 
	IN   R30,0x37
	ANDI R30,0xFE
	OUT  0x37,R30
;     597 
;     598 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     599 }
	RJMP _0x18C
;     600 
;     601 // ============================== TIMER1 TEST =================================
;     602 // [μ]: void
;     603 // ----------------------------------------------------------------------------
;     604 void timer1_test(void)
;     605 {
_timer1_test:
;     606 int exit_flg = 0;
;     607 
;     608 	printf("=================== TIMER1 TEST =================\r\n");
	CALL SUBOPT_0x11
;	exit_flg -> R16,R17
	__POINTW1FN _0,1006
	CALL SUBOPT_0xB
;     609 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xD
;     610 	printf("- interrupt    : TIMER1 Overfow 10.0ms           \r\n");
	__POINTW1FN _0,1058
	CALL SUBOPT_0xB
;     611 	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	__POINTW1FN _0,1110
	CALL SUBOPT_0xB
;     612 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xE
;     613 
;     614 // Timer/Counter1 (Overflow)
;     615 	TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
;     616 	TCCR1B=0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	LDI  R30,LOW(3)
	OUT  0x2E,R30
;     617 	TCNT1 = 63035;						// 65535 - 2500 = 63035
	LDI  R30,LOW(63035)
	LDI  R31,HIGH(63035)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
;     618 	OCR1AH=0x00;
	LDI  R30,LOW(0)
	OUT  0x2B,R30
;     619 	OCR1AL=0x00;
	OUT  0x2A,R30
;     620 	OCR1BH=0x00;
	OUT  0x29,R30
;     621 	OCR1BL=0x00;
	OUT  0x28,R30
;     622 	OCR1CH=0x00;
	STS  121,R30
;     623 	OCR1CL=0x00;
	STS  120,R30
;     624 	TIMSK |= 0x04;						// TIMER1 ͷƮ 㰡
	IN   R30,0x37
	ORI  R30,4
	OUT  0x37,R30
;     625 
;     626 	timer1_cnt = 0;						// TIMER1 ͷƮ ī Ŭ
	CLR  R10
	CLR  R11
;     627 	com1_rx_eflg = 0;
	CLR  R4
;     628 	while(exit_flg == 0){					// COM1  ˻
_0x51:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x53
;     629 		if(com1_rx_eflg){
	TST  R4
	BREQ _0x54
;     630 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x55
	__GETWRN 16,17,1
;     631 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x56
_0x55:
	ST   -Y,R5
	CALL _putchar
;     632 			com1_rx_eflg = 0;
_0x56:
	CLR  R4
;     633 		}
;     634 		if(timer1_cnt >= 100){				// 1s üũ
_0x54:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R10,R30
	CPC  R11,R31
	BRLT _0x57
;     635 			printf("TIMER1 Overflow Interrupt\r\n");
	__POINTW1FN _0,1162
	CALL SUBOPT_0xB
;     636 			timer1_cnt = 0;
	CLR  R10
	CLR  R11
;     637 		}
;     638 	}
_0x57:
	RJMP _0x51
_0x53:
;     639 
;     640 // Timer/Counter1 
;     641 	TCCR1A=0x00;
	CALL SUBOPT_0x2
;     642 	TCCR1B=0x00;
;     643 	TCNT1H=0x00;
;     644 	TCNT1L=0x00;
;     645 	OCR1AH=0x00;
;     646 	OCR1AL=0x00;
;     647 	OCR1BH=0x00;
;     648 	OCR1BL=0x00;
;     649 	OCR1CH=0x00;
;     650 	OCR1CL=0x00;
;     651 	TIMSK &= 0xfb;						// TIMER1 ͷƮ 
	IN   R30,0x37
	ANDI R30,0xFB
	OUT  0x37,R30
;     652 
;     653 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     654 }
	RJMP _0x18C
;     655 
;     656 // ============================== TIMER2 TEST =================================
;     657 // [μ]: void
;     658 // ----------------------------------------------------------------------------
;     659 void timer2_test(void)
;     660 {
_timer2_test:
;     661 int exit_flg = 0;
;     662 
;     663 	printf("=================== TIMER2 TEST =================\r\n");
	CALL SUBOPT_0x11
;	exit_flg -> R16,R17
	__POINTW1FN _0,1190
	CALL SUBOPT_0xB
;     664 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xD
;     665 	printf("- interrupt    : TIMER2 Overfow 9.9984ms         \r\n");
	__POINTW1FN _0,1242
	CALL SUBOPT_0xB
;     666 	printf("- message disp : 9.9984ms * 100 = 999.84ms       \r\n");
	__POINTW1FN _0,926
	CALL SUBOPT_0xB
;     667 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xE
;     668 
;     669 // Timer/Counter2 (Overflow)
;     670 	TCCR2 = 0x05;						// system clock,16,000,000 / 1024 = 15.625Khz
	LDI  R30,LOW(5)
	OUT  0x25,R30
;     671 	TCNT2 = 99;						// 255-156 = 99
	LDI  R30,LOW(99)
	OUT  0x24,R30
;     672 	OCR2 = 0x00;
	LDI  R30,LOW(0)
	OUT  0x23,R30
;     673 	TIMSK |= 0x40;						// TIMER2 ͷƮ 㰡
	IN   R30,0x37
	ORI  R30,0x40
	OUT  0x37,R30
;     674 
;     675 	timer2_cnt = 0;						// TIMER2 ͷƮ ī Ŭ
	CLR  R12
	CLR  R13
;     676 	com1_rx_eflg = 0;
	CLR  R4
;     677 	while(exit_flg == 0){
_0x58:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x5A
;     678 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BREQ _0x5B
;     679 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x5C
	__GETWRN 16,17,1
;     680 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x5D
_0x5C:
	ST   -Y,R5
	CALL _putchar
;     681 			com1_rx_eflg = 0;
_0x5D:
	CLR  R4
;     682 		}
;     683 		if(timer2_cnt >= 100){				// 999.84ms üũ
_0x5B:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R12,R30
	CPC  R13,R31
	BRLT _0x5E
;     684 			printf("TIMER2 Overflow Interrupt\r\n");
	__POINTW1FN _0,1294
	CALL SUBOPT_0xB
;     685 			timer2_cnt = 0;
	CLR  R12
	CLR  R13
;     686 		}
;     687 	}
_0x5E:
	RJMP _0x58
_0x5A:
;     688 
;     689 // Timer/Counter2 
;     690 	TCCR2 = 0x00;
	CALL SUBOPT_0x3
;     691 	TCNT2 = 0;
;     692 	OCR2 = 0x00;
;     693 	TIMSK &= 0xbf;						// TIMER2 ͷƮ 
	IN   R30,0x37
	ANDI R30,0xBF
	OUT  0x37,R30
;     694 
;     695 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     696 }
	RJMP _0x18C
;     697 
;     698 // ============================== TIMER3 TEST =================================
;     699 // [μ]: void
;     700 // ----------------------------------------------------------------------------
;     701 void timer3_test(void)
;     702 {
_timer3_test:
;     703 int exit_flg = 0;
;     704 
;     705 	printf("=================== TIMER3 TEST =================\r\n");
	CALL SUBOPT_0x11
;	exit_flg -> R16,R17
	__POINTW1FN _0,1322
	CALL SUBOPT_0xB
;     706 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xD
;     707 	printf("- interrupt    : TIMER3 Overfow 10.0ms           \r\n");
	__POINTW1FN _0,1374
	CALL SUBOPT_0xB
;     708 	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	__POINTW1FN _0,1110
	CALL SUBOPT_0xB
;     709 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xE
;     710 
;     711 // Timer/Counter3 (Overflow)
;     712 	TCCR3A=0x00;
	LDI  R30,LOW(0)
	STS  139,R30
;     713 	TCCR3B=0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	LDI  R30,LOW(3)
	STS  138,R30
;     714 	TCNT3H=0xf6;  						// 65535 - 2500 = 63035
	CALL SUBOPT_0x8
;     715 	TCNT3L=0x3b;
;     716 
;     717 	OCR3AH=0x00;
	LDI  R30,LOW(0)
	STS  135,R30
;     718 	OCR3AL=0x00;
	STS  134,R30
;     719 	OCR3BH=0x00;
	STS  133,R30
;     720 	OCR3BL=0x00;
	STS  132,R30
;     721 	OCR3CH=0x00;
	STS  131,R30
;     722 	OCR3CL=0x00;
	STS  130,R30
;     723 	ETIMSK |= 0x04;						// TIMER3 ͷƮ 㰡
	LDS  R30,125
	ORI  R30,4
	STS  125,R30
;     724 
;     725 	timer3_cnt = 0;						// TIMER3 ͷƮ ī Ŭ
	LDI  R30,0
	STS  _timer3_cnt,R30
	STS  _timer3_cnt+1,R30
;     726 	com1_rx_eflg = 0;
	CLR  R4
;     727 	while(exit_flg == 0){					// COM1  ˻
_0x5F:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x61
;     728 		if(com1_rx_eflg){
	TST  R4
	BREQ _0x62
;     729 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x63
	__GETWRN 16,17,1
;     730 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x64
_0x63:
	ST   -Y,R5
	CALL _putchar
;     731 			com1_rx_eflg = 0;
_0x64:
	CLR  R4
;     732 		}
;     733 		if(timer3_cnt >= 100){				// 1s üũ
_0x62:
	LDS  R26,_timer3_cnt
	LDS  R27,_timer3_cnt+1
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRLT _0x65
;     734 			printf("TIMER3 Overflow Interrupt\r\n");
	__POINTW1FN _0,1426
	CALL SUBOPT_0xB
;     735 			timer3_cnt = 0;
	LDI  R30,0
	STS  _timer3_cnt,R30
	STS  _timer3_cnt+1,R30
;     736 		}
;     737 	}
_0x65:
	RJMP _0x5F
_0x61:
;     738 
;     739 // Timer/Counter3 
;     740 	TCCR3A=0x00;
	CALL SUBOPT_0x4
;     741 	TCCR3B=0x00;
;     742 	TCNT3H=0x00;
;     743 	TCNT3L=0x00;
;     744 	OCR3AH=0x00;
;     745 	OCR3AL=0x00;
;     746 	OCR3BH=0x00;
;     747 	OCR3BL=0x00;
;     748 	OCR3CH=0x00;
;     749 	OCR3CL=0x00;
;     750 	ETIMSK &= 0xfb;						// TIMER3 ͷƮ 
	LDS  R30,125
	ANDI R30,0xFB
	STS  125,R30
;     751 
;     752 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     753 }
_0x18C:
	LD   R16,Y+
	LD   R17,Y+
	RET
;     754 
;     755 // ============================== EXINT0,1 TEST ===============================
;     756 // [μ]: void
;     757 // ----------------------------------------------------------------------------
;     758 void exint_test(void)
;     759 {
_exint_test:
;     760 int exit_flg = 0;
;     761 
;     762 	printf("=================== EXINT0,1 TEST ===============\r\n");
	CALL SUBOPT_0x11
;	exit_flg -> R16,R17
	__POINTW1FN _0,1454
	CALL SUBOPT_0xB
;     763 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xD
;     764 	printf("- interrupt : INT0 Falling Edge                  \r\n");
	__POINTW1FN _0,1506
	CALL SUBOPT_0xB
;     765 	printf("-             INT1 Falling Edge                  \r\n");
	__POINTW1FN _0,1558
	CALL SUBOPT_0xB
;     766 	printf("-             INT2 Falling Edge                  \r\n");
	__POINTW1FN _0,1610
	CALL SUBOPT_0xB
;     767 	printf("-             INT3 Falling Edge                  \r\n");
	__POINTW1FN _0,1662
	CALL SUBOPT_0xB
;     768 	printf("-             INT4 Falling Edge                  \r\n");
	__POINTW1FN _0,1714
	CALL SUBOPT_0xB
;     769 	printf("-             INT5 Falling Edge                  \r\n");
	__POINTW1FN _0,1766
	CALL SUBOPT_0xB
;     770 	printf("-             INT6 Falling Edge                  \r\n");
	__POINTW1FN _0,1818
	CALL SUBOPT_0xB
;     771 	printf("-             INT7 Falling Edge                  \r\n");
	__POINTW1FN _0,1870
	CALL SUBOPT_0xB
;     772 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xE
;     773 
;     774 // External Interrupt(s) 
;     775 // INT0 Mode: Falling Edge
;     776 // INT1 Mode: Falling Edge
;     777 // INT2 Mode: Falling Edge
;     778 // INT3 Mode: Falling Edge
;     779 // INT4 Mode: Falling Edge
;     780 // INT5 Mode: Falling Edge
;     781 // INT6 Mode: Falling Edge
;     782 // INT7 Mode: Falling Edge
;     783 	EICRA=0xAA;
	LDI  R30,LOW(170)
	STS  106,R30
;     784 	EICRB=0xAA;
	OUT  0x3A,R30
;     785 	EIMSK=0xFF;
	LDI  R30,LOW(255)
	OUT  0x39,R30
;     786 	EIFR=0xFF;
	OUT  0x38,R30
;     787 
;     788 	exint0_flg = exint1_flg = exint2_flg = 0;		// EXINT0,1 ͷƮ ÷ Ŭ
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STS  _exint2_flg,R30
	STS  _exint2_flg+1,R31
	STS  _exint1_flg,R30
	STS  _exint1_flg+1,R31
	STS  _exint0_flg,R30
	STS  _exint0_flg+1,R31
;     789 	com1_rx_eflg = 0;
	CLR  R4
;     790 	while(exit_flg == 0){
_0x66:
	MOV  R0,R16
	OR   R0,R17
	BREQ PC+3
	JMP _0x68
;     791 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BREQ _0x69
;     792 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x6A
	__GETWRN 16,17,1
;     793 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x6B
_0x6A:
	ST   -Y,R5
	CALL _putchar
;     794 			com1_rx_eflg = 0;
_0x6B:
	CLR  R4
;     795 		}
;     796 		if(exint0_flg){					// EXINT0 ͷƮ ÷ üũ
_0x69:
	LDS  R30,_exint0_flg
	LDS  R31,_exint0_flg+1
	SBIW R30,0
	BREQ _0x6C
;     797 			printf("EXINT0 Interrupt\r\n");
	__POINTW1FN _0,1922
	CALL SUBOPT_0xB
;     798 			exint0_flg = 0;
	LDI  R30,0
	STS  _exint0_flg,R30
	STS  _exint0_flg+1,R30
;     799 		}
;     800 		if(exint1_flg){					// EXINT1 ͷƮ ÷ üũ
_0x6C:
	LDS  R30,_exint1_flg
	LDS  R31,_exint1_flg+1
	SBIW R30,0
	BREQ _0x6D
;     801 			printf("EXINT1 Interrupt\r\n");
	__POINTW1FN _0,1941
	CALL SUBOPT_0xB
;     802 			exint1_flg = 0;
	LDI  R30,0
	STS  _exint1_flg,R30
	STS  _exint1_flg+1,R30
;     803 		}
;     804 		if(exint2_flg){					// EXINT2 ͷƮ ÷ üũ
_0x6D:
	LDS  R30,_exint2_flg
	LDS  R31,_exint2_flg+1
	SBIW R30,0
	BREQ _0x6E
;     805 			printf("EXINT2 Interrupt\r\n");
	__POINTW1FN _0,1960
	CALL SUBOPT_0xB
;     806 			exint2_flg = 0;
	LDI  R30,0
	STS  _exint2_flg,R30
	STS  _exint2_flg+1,R30
;     807 		}
;     808 		if(exint3_flg){					// EXINT3 ͷƮ ÷ üũ
_0x6E:
	LDS  R30,_exint3_flg
	LDS  R31,_exint3_flg+1
	SBIW R30,0
	BREQ _0x6F
;     809 			printf("EXINT3 Interrupt\r\n");
	__POINTW1FN _0,1979
	CALL SUBOPT_0xB
;     810 			exint3_flg = 0;
	LDI  R30,0
	STS  _exint3_flg,R30
	STS  _exint3_flg+1,R30
;     811 		}
;     812 		if(exint4_flg){					// EXINT4 ͷƮ ÷ üũ
_0x6F:
	LDS  R30,_exint4_flg
	LDS  R31,_exint4_flg+1
	SBIW R30,0
	BREQ _0x70
;     813 			printf("EXINT4 Interrupt\r\n");
	__POINTW1FN _0,1998
	CALL SUBOPT_0xB
;     814 			exint4_flg = 0;
	LDI  R30,0
	STS  _exint4_flg,R30
	STS  _exint4_flg+1,R30
;     815 		}
;     816 		if(exint5_flg){					// EXINT5 ͷƮ ÷ üũ
_0x70:
	LDS  R30,_exint5_flg
	LDS  R31,_exint5_flg+1
	SBIW R30,0
	BREQ _0x71
;     817 			printf("EXINT5 Interrupt\r\n");
	__POINTW1FN _0,2017
	CALL SUBOPT_0xB
;     818 			exint5_flg = 0;
	LDI  R30,0
	STS  _exint5_flg,R30
	STS  _exint5_flg+1,R30
;     819 		}
;     820 		if(exint6_flg){					// EXINT6 ͷƮ ÷ üũ
_0x71:
	LDS  R30,_exint6_flg
	LDS  R31,_exint6_flg+1
	SBIW R30,0
	BREQ _0x72
;     821 			printf("EXINT6 Interrupt\r\n");
	__POINTW1FN _0,2036
	CALL SUBOPT_0xB
;     822 			exint6_flg = 0;
	LDI  R30,0
	STS  _exint6_flg,R30
	STS  _exint6_flg+1,R30
;     823 		}
;     824 		if(exint7_flg){					// EXINT7 ͷƮ ÷ üũ
_0x72:
	LDS  R30,_exint7_flg
	LDS  R31,_exint7_flg+1
	SBIW R30,0
	BREQ _0x73
;     825 			printf("EXINT7 Interrupt\r\n");
	__POINTW1FN _0,2055
	CALL SUBOPT_0xB
;     826 			exint7_flg = 0;
	LDI  R30,0
	STS  _exint7_flg,R30
	STS  _exint7_flg+1,R30
;     827 		}
;     828 	}
_0x73:
	RJMP _0x66
_0x68:
;     829 
;     830 // External Interrupt(s) 
;     831 	EICRA=0x00;
	CALL SUBOPT_0x5
;     832 	EICRB=0x00;
;     833 	EIMSK=0x00;
;     834 	EIFR=0x00;
	OUT  0x38,R30
;     835 
;     836 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     837 }
	RJMP _0x189
;     838 
;     839 // ============================== A/D POLLING TEST ============================
;     840 // [μ]: void
;     841 // ----------------------------------------------------------------------------
;     842 void ad_polling_test(void)
;     843 {
_ad_polling_test:
;     844 unsigned datau;
;     845 int exit_flg = 0;
;     846 
;     847 	printf("================= A/D POLLING TEST ==============\r\n");
	CALL SUBOPT_0xC
;	datau -> R16,R17
;	exit_flg -> R18,R19
	__POINTW1FN _0,2074
	CALL SUBOPT_0xB
;     848 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xD
;     849 	printf("- 1  : CH0 READ                                  \r\n");
	__POINTW1FN _0,2126
	CALL SUBOPT_0xB
;     850 	printf("- 2  : CH1 READ                                  \r\n");
	__POINTW1FN _0,2178
	CALL SUBOPT_0xB
;     851 	printf("- 3  : CH2 READ                                  \r\n");
	__POINTW1FN _0,2230
	CALL SUBOPT_0xB
;     852 	printf("- 4  : CH3 READ                                  \r\n");
	__POINTW1FN _0,2282
	CALL SUBOPT_0xB
;     853 	printf("- 5  : CH4 READ                                  \r\n");
	__POINTW1FN _0,2334
	CALL SUBOPT_0xB
;     854 	printf("- 6  : CH5 READ                                  \r\n");
	__POINTW1FN _0,2386
	CALL SUBOPT_0xB
;     855 	printf("- 7  : CH6 READ                                  \r\n");
	__POINTW1FN _0,2438
	CALL SUBOPT_0xB
;     856 	printf("- 8  : CH7 READ                                  \r\n");
	__POINTW1FN _0,2490
	CALL SUBOPT_0xB
;     857 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xE
;     858 
;     859 // ADC initialization 
;     860 	ADMUX = 0x00;						//   AREF
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     861 	ADCSRA = 0x87;						// ADC Enable,ADC Clock 125.000Khz
	LDI  R30,LOW(135)
	CALL SUBOPT_0x12
;     862 	SFIOR &= 0xEF;
;     863 
;     864 	com1_rx_eflg = 0;
	CLR  R4
;     865 	while(exit_flg == 0){
_0x74:
	MOV  R0,R18
	OR   R0,R19
	BREQ PC+3
	JMP _0x76
;     866 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BRNE PC+3
	JMP _0x77
;     867 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x78
	__GETWRN 18,19,1
;     868 			else if(com1_rx_data == '1') datau = ad_read(0);// CH0 
	RJMP _0x79
_0x78:
	LDI  R30,LOW(49)
	CP   R30,R5
	BRNE _0x7A
	LDI  R30,LOW(0)
	CALL SUBOPT_0x13
;     869 			else if(com1_rx_data == '2') datau = ad_read(1);// CH1 
	RJMP _0x7B
_0x7A:
	LDI  R30,LOW(50)
	CP   R30,R5
	BRNE _0x7C
	LDI  R30,LOW(1)
	CALL SUBOPT_0x13
;     870 			else if(com1_rx_data == '3') datau = ad_read(2);// CH2 
	RJMP _0x7D
_0x7C:
	LDI  R30,LOW(51)
	CP   R30,R5
	BRNE _0x7E
	LDI  R30,LOW(2)
	CALL SUBOPT_0x13
;     871 			else if(com1_rx_data == '4') datau = ad_read(3);// CH3 
	RJMP _0x7F
_0x7E:
	LDI  R30,LOW(52)
	CP   R30,R5
	BRNE _0x80
	LDI  R30,LOW(3)
	CALL SUBOPT_0x13
;     872 			else if(com1_rx_data == '5') datau = ad_read(4);// CH4 
	RJMP _0x81
_0x80:
	LDI  R30,LOW(53)
	CP   R30,R5
	BRNE _0x82
	LDI  R30,LOW(4)
	CALL SUBOPT_0x13
;     873 			else if(com1_rx_data == '6') datau = ad_read(5);// CH5 
	RJMP _0x83
_0x82:
	LDI  R30,LOW(54)
	CP   R30,R5
	BRNE _0x84
	LDI  R30,LOW(5)
	CALL SUBOPT_0x13
;     874 			else if(com1_rx_data == '7') datau = ad_read(6);// CH6 
	RJMP _0x85
_0x84:
	LDI  R30,LOW(55)
	CP   R30,R5
	BRNE _0x86
	LDI  R30,LOW(6)
	CALL SUBOPT_0x13
;     875 			else if(com1_rx_data == '8') datau = ad_read(7);// CH7 
	RJMP _0x87
_0x86:
	LDI  R30,LOW(56)
	CP   R30,R5
	BRNE _0x88
	LDI  R30,LOW(7)
	CALL SUBOPT_0x13
;     876 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x89
_0x88:
	ST   -Y,R5
	CALL _putchar
;     877 			// A/D  ǥ
;     878 			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("ADC CH%d > %d\r\n",(com1_rx_data&0x0f)-1,datau);
_0x89:
_0x87:
_0x85:
_0x83:
_0x81:
_0x7F:
_0x7D:
_0x7B:
_0x79:
	LDI  R30,LOW(49)
	CP   R5,R30
	BRLO _0x8B
	LDI  R30,LOW(56)
	CP   R30,R5
	BRSH _0x8C
_0x8B:
	RJMP _0x8A
_0x8C:
	__POINTW1FN _0,2542
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R5
	ANDI R30,LOW(0xF)
	SUBI R30,LOW(1)
	CALL SUBOPT_0x14
	MOVW R30,R16
	CALL SUBOPT_0x15
;     879 			com1_rx_eflg = 0;
_0x8A:
	CLR  R4
;     880 		}
;     881 	}
_0x77:
	RJMP _0x74
_0x76:
;     882 
;     883 // ADC initialization 
;     884 	ADMUX = 0x00;
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     885 	ADCSRA = 0x00;
	CALL SUBOPT_0x12
;     886 	SFIOR &= 0xEF;
;     887 
;     888 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     889 }
_0x18B:
	CALL __LOADLOCR4
	ADIW R28,4
	RET
;     890 
;     891 // ============================== A/D POLLING TEST ============================
;     892 // [μ]: unsigned char adc_input
;     893 // ITEM1 : AD CH(0-7)
;     894 // []: A/D 10bit
;     895 // ----------------------------------------------------------------------------
;     896 unsigned int ad_read(unsigned char adc_input)
;     897 {
_ad_read:
;     898 	ADMUX = adc_input;					// ADREF(0) + CH
;	adc_input -> Y+0
	LD   R30,Y
	OUT  0x7,R30
;     899 	ADCSRA |= 0x40;						// AD conversion 
	SBI  0x6,6
;     900 	while((ADCSRA & 0x10) == 0);				//  Ϸ 
_0x8D:
	SBIS 0x6,4
	RJMP _0x8D
;     901 	ADCSRA |= 0x10;						// AD ÷ Ŭ
	SBI  0x6,4
;     902 	return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	RJMP _0x188
;     903 }
;     904 
;     905 // ============================== A/D INTERRUPT TEST ==========================
;     906 // [μ]: void
;     907 // ----------------------------------------------------------------------------
;     908 void ad_interrupt_test(void)
;     909 {
_ad_interrupt_test:
;     910 int exit_flg = 0;
;     911 
;     912 	printf("================ A/D INTEERRUPT TEST ============\r\n");
	CALL SUBOPT_0x11
;	exit_flg -> R16,R17
	__POINTW1FN _0,2558
	CALL SUBOPT_0xB
;     913 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xD
;     914 	printf("- 1  : CH0 READ                                  \r\n");
	__POINTW1FN _0,2126
	CALL SUBOPT_0xB
;     915 	printf("- 2  : CH1 READ                                  \r\n");
	__POINTW1FN _0,2178
	CALL SUBOPT_0xB
;     916 	printf("- 3  : CH2 READ                                  \r\n");
	__POINTW1FN _0,2230
	CALL SUBOPT_0xB
;     917 	printf("- 4  : CH3 READ                                  \r\n");
	__POINTW1FN _0,2282
	CALL SUBOPT_0xB
;     918 	printf("- 5  : CH4 READ                                  \r\n");
	__POINTW1FN _0,2334
	CALL SUBOPT_0xB
;     919 	printf("- 6  : CH5 READ                                  \r\n");
	__POINTW1FN _0,2386
	CALL SUBOPT_0xB
;     920 	printf("- 7  : CH6 READ                                  \r\n");
	__POINTW1FN _0,2438
	CALL SUBOPT_0xB
;     921 	printf("- 8  : CH7 READ                                  \r\n");
	__POINTW1FN _0,2490
	CALL SUBOPT_0xB
;     922 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xE
;     923 
;     924 // ADC initialization 
;     925 	ADMUX = 0x00;						//   AREF
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     926 	ADCSRA = 0x8f;						// ADC Enable,ADC Clock 125.000Khz,ADC ȯ ͷƮ Ȱȭ
	LDI  R30,LOW(143)
	CALL SUBOPT_0x12
;     927 	SFIOR &= 0xEF;
;     928 
;     929 	adc_int_flg = 0;					// ADCϷ ͷƮ ÷
	LDI  R30,0
	STS  _adc_int_flg,R30
	STS  _adc_int_flg+1,R30
;     930 	adc_int_ch = 0;						// ADC CH = CH0
	LDI  R30,0
	STS  _adc_int_ch,R30
	STS  _adc_int_ch+1,R30
;     931 	com1_rx_eflg = 0;
	CLR  R4
;     932 	while(exit_flg == 0){
_0x90:
	MOV  R0,R16
	OR   R0,R17
	BREQ PC+3
	JMP _0x92
;     933 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BRNE PC+3
	JMP _0x93
;     934 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x94
	__GETWRN 16,17,1
;     935 			else if(com1_rx_data == '1') ad_start(0);// CH0 
	RJMP _0x95
_0x94:
	LDI  R30,LOW(49)
	CP   R30,R5
	BRNE _0x96
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _ad_start
;     936 			else if(com1_rx_data == '2') ad_start(1);// CH1 
	RJMP _0x97
_0x96:
	LDI  R30,LOW(50)
	CP   R30,R5
	BRNE _0x98
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _ad_start
;     937 			else if(com1_rx_data == '3') ad_start(2);// CH2 
	RJMP _0x99
_0x98:
	LDI  R30,LOW(51)
	CP   R30,R5
	BRNE _0x9A
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _ad_start
;     938 			else if(com1_rx_data == '4') ad_start(3);// CH3 
	RJMP _0x9B
_0x9A:
	LDI  R30,LOW(52)
	CP   R30,R5
	BRNE _0x9C
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _ad_start
;     939 			else if(com1_rx_data == '5') ad_start(4);// CH4 
	RJMP _0x9D
_0x9C:
	LDI  R30,LOW(53)
	CP   R30,R5
	BRNE _0x9E
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _ad_start
;     940 			else if(com1_rx_data == '6') ad_start(5);// CH5 
	RJMP _0x9F
_0x9E:
	LDI  R30,LOW(54)
	CP   R30,R5
	BRNE _0xA0
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _ad_start
;     941 			else if(com1_rx_data == '7') ad_start(6);// CH6 
	RJMP _0xA1
_0xA0:
	LDI  R30,LOW(55)
	CP   R30,R5
	BRNE _0xA2
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _ad_start
;     942 			else if(com1_rx_data == '8') ad_start(7);// CH7 
	RJMP _0xA3
_0xA2:
	LDI  R30,LOW(56)
	CP   R30,R5
	BRNE _0xA4
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _ad_start
;     943 			else putchar(com1_rx_data);		// ݼ
	RJMP _0xA5
_0xA4:
	ST   -Y,R5
	CALL _putchar
;     944 			// A/D  ǥ
;     945 			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("STAT ADC ");
_0xA5:
_0xA3:
_0xA1:
_0x9F:
_0x9D:
_0x9B:
_0x99:
_0x97:
_0x95:
	LDI  R30,LOW(49)
	CP   R5,R30
	BRLO _0xA7
	LDI  R30,LOW(56)
	CP   R30,R5
	BRSH _0xA8
_0xA7:
	RJMP _0xA6
_0xA8:
	__POINTW1FN _0,2610
	CALL SUBOPT_0xB
;     946 			com1_rx_eflg = 0;
_0xA6:
	CLR  R4
;     947 		}
;     948 		if(adc_int_flg){				// ADC  Ϸ ͷƮ ÷
_0x93:
	LDS  R30,_adc_int_flg
	LDS  R31,_adc_int_flg+1
	SBIW R30,0
	BREQ _0xA9
;     949 			printf("CH%d > %d\r\n",adc_int_ch,adc_int_data);// ADC CH  ǥ
	__POINTW1FN _0,2546
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_adc_int_ch
	LDS  R31,_adc_int_ch+1
	CALL __CWD1
	CALL __PUTPARD1
	LDS  R30,_adc_int_data
	LDS  R31,_adc_int_data+1
	CALL SUBOPT_0x15
;     950 			adc_int_flg = 0;
	LDI  R30,0
	STS  _adc_int_flg,R30
	STS  _adc_int_flg+1,R30
;     951 		}
;     952 	}
_0xA9:
	RJMP _0x90
_0x92:
;     953 
;     954 // ADC initialization 
;     955 	ADMUX = 0x00;
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     956 	ADCSRA = 0x00;
	CALL SUBOPT_0x12
;     957 	SFIOR &= 0xEF;
;     958 
;     959 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     960 }
	RJMP _0x189
;     961 
;     962 // ============================== A/D POLLING TEST ============================
;     963 // [μ]: unsigned char adc_input
;     964 // ITEM1 : AD CH(0-7)
;     965 // []: A/D 10bit
;     966 // ----------------------------------------------------------------------------
;     967 void ad_start(unsigned char adc_input)
;     968 {
_ad_start:
;     969 	adc_int_ch = adc_input;					// ADC CH 
;	adc_input -> Y+0
	LD   R30,Y
	LDI  R31,0
	STS  _adc_int_ch,R30
	STS  _adc_int_ch+1,R31
;     970 	ADMUX = adc_input;					// ADREF(0) + CH
	LD   R30,Y
	OUT  0x7,R30
;     971 	ADCSRA |= 0x40;						// AD conversion 
	SBI  0x6,6
;     972 }
	RJMP _0x188
;     973 
;     974 // ================================ EEPROM TEST ===============================
;     975 // [μ]: void
;     976 // ----------------------------------------------------------------------------
;     977 void eeprom_test(void)
;     978 {
_eeprom_test:
;     979 char ch,buff[100],buff1[30],buff2[30],buff3[30];
;     980 unsigned char uch;
;     981 int i,j,cnt,exit_flg = 0;
;     982 unsigned int saddr,ecnt;
;     983 
;     984 	printf("============== INTERNAL EEPROM TEST =============\r\n");
	SBIW R28,63
	SBIW R28,63
	SBIW R28,63
	SBIW R28,9
	LDI  R24,2
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	LDI  R30,LOW(_0xAA*2)
	LDI  R31,HIGH(_0xAA*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	ch -> R17
;	buff -> Y+104
;	buff1 -> Y+74
;	buff2 -> Y+44
;	buff3 -> Y+14
;	uch -> R16
;	i -> R18,R19
;	j -> R20,R21
;	cnt -> Y+12
;	exit_flg -> Y+10
;	saddr -> Y+8
;	ecnt -> Y+6
	__POINTW1FN _0,2620
	CALL SUBOPT_0xB
;     985 	printf("- 0 : TOP menu                                   \r\n");
	__POINTW1FN _0,2672
	CALL SUBOPT_0xB
;     986 	printf("  1 : Read  Data(000-fffh)                       \r\n");
	__POINTW1FN _0,2724
	CALL SUBOPT_0xB
;     987 	printf("  2 : Write Data(000-fffh)                       \r\n");
	__POINTW1FN _0,2776
	CALL SUBOPT_0xB
;     988 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xE
;     989 
;     990 	com1_rx_eflg = 0;
	CLR  R4
;     991 	while(exit_flg == 0){
_0xAB:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SBIW R30,0
	BREQ PC+3
	JMP _0xAD
;     992 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BRNE PC+3
	JMP _0xAE
;     993 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0xAF
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+10,R30
	STD  Y+10+1,R31
;     994 			else if(com1_rx_data == '1'){
	RJMP _0xB0
_0xAF:
	LDI  R30,LOW(49)
	CP   R30,R5
	BREQ PC+3
	JMP _0xB1
;     995 				i = j = cnt = 0;
	CALL SUBOPT_0x16
;     996 				printf("\r\nREAD(###(Add),***(Count)) > ");
	__POINTW1FN _0,2828
	CALL SUBOPT_0xB
;     997 				urx_string(buff);
	CALL SUBOPT_0x17
;     998 				ch = buff[i++];			//  ˻ ڷ 
;     999 				while(ch != 0x0){
_0xB2:
	CPI  R17,0
	BREQ _0xB4
;    1000 					if((ch == ':') || (ch == ',') || (ch == ' ')){
	CPI  R17,58
	BREQ _0xB6
	CPI  R17,44
	BREQ _0xB6
	CPI  R17,32
	BRNE _0xB5
_0xB6:
;    1001 						j = 0;
	CALL SUBOPT_0x18
;    1002 						cnt++;
;    1003 					}
;    1004 					else{
	RJMP _0xB8
_0xB5:
;    1005 						if(cnt == 0){
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BRNE _0xB9
;    1006 							buff1[j++] = ch;
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1A
;    1007 							buff1[j] = 0x0;
	RJMP _0x18D
;    1008 						}
;    1009 						else if(cnt == 1){
_0xB9:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,1
	BRNE _0xBB
;    1010 				    			buff2[j++] = ch;
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1B
;    1011 				    			buff2[j] = 0x0;
_0x18D:
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(0)
	ST   X,R30
;    1012 						}
;    1013 			    		}
_0xBB:
_0xB8:
;    1014 				    	ch = buff[i++];
	CALL SUBOPT_0x1C
;    1015 				}
	RJMP _0xB2
_0xB4:
;    1016 				if(cnt == 1){			// ˻ 
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,1
	BREQ PC+3
	JMP _0xBC
;    1017 					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
	CALL SUBOPT_0x1D
;    1018 					ecnt = (unsigned int)atoh(buff2);// ī ȯ(HEX)
;    1019 					printf("%04X > ",saddr);// ּ ǥ
	__POINTW1FN _0,2859
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL SUBOPT_0x1E
;    1020 					cnt = 0;
	LDI  R30,0
	STD  Y+12,R30
	STD  Y+12+1,R30
;    1021 			   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ
	__GETWRN 18,19,0
_0xBE:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R30,R18
	CPC  R31,R19
	BRLO _0xBF
;    1022 						uch = EEPROM_read(saddr);//  
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _EEPROM_read
	MOV  R16,R30
;    1023 						printf("%02X ",uch);// Ÿ ǥ
	CALL SUBOPT_0x1F
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;    1024 						cnt++;
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	STD  Y+12,R30
	STD  Y+12+1,R31
;    1025 						if(cnt == 16){// 1 ǥ
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,16
	BRNE _0xC0
;    1026 							cnt = 0;
	LDI  R30,0
	STD  Y+12,R30
	STD  Y+12+1,R30
;    1027 							if(i+1 <= ecnt) printf("\r\n%04X > ",saddr+1);// ּ ǥ
	MOVW R26,R18
	ADIW R26,1
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R30,R26
	CPC  R31,R27
	BRLO _0xC1
	__POINTW1FN _0,2873
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,1
	CALL SUBOPT_0x1E
;    1028 						}
_0xC1:
;    1029 				    	}
_0xC0:
	CALL SUBOPT_0x20
	RJMP _0xBE
_0xBF:
;    1030 					printf("\r\nRead OK\r\n");
	__POINTW1FN _0,2883
	CALL SUBOPT_0xB
;    1031 				}
;    1032 			}
_0xBC:
;    1033 			else if(com1_rx_data == '2'){
	RJMP _0xC2
_0xB1:
	LDI  R30,LOW(50)
	CP   R30,R5
	BREQ PC+3
	JMP _0xC3
;    1034 				i = j = cnt = 0;
	CALL SUBOPT_0x16
;    1035 				printf("\r\nWRITE(###(Addr),***(Count),**(Data)) > ");
	__POINTW1FN _0,2895
	CALL SUBOPT_0xB
;    1036 				urx_string(buff);
	CALL SUBOPT_0x17
;    1037 				ch = buff[i++];			//  ˻ ڷ 
;    1038 				while(ch != 0x0){
_0xC4:
	CPI  R17,0
	BREQ _0xC6
;    1039 					if((ch == ':') || (ch == ',') || (ch == ' ')){
	CPI  R17,58
	BREQ _0xC8
	CPI  R17,44
	BREQ _0xC8
	CPI  R17,32
	BRNE _0xC7
_0xC8:
;    1040 						j = 0;
	CALL SUBOPT_0x18
;    1041 						cnt++;
;    1042 					}
;    1043 					else{
	RJMP _0xCA
_0xC7:
;    1044 						if(cnt == 0){
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BRNE _0xCB
;    1045 							buff1[j++] = ch;
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1A
;    1046 							buff1[j] = 0x0;
	RJMP _0x18E
;    1047 						}
;    1048 						else if(cnt == 1){
_0xCB:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,1
	BRNE _0xCD
;    1049 							buff2[j++] = ch;
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1B
;    1050 							buff2[j] = 0x0;
	RJMP _0x18E
;    1051 						}
;    1052 						else if(cnt == 2){
_0xCD:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,2
	BRNE _0xCF
;    1053 							buff3[j++] = ch;
	CALL SUBOPT_0x19
	MOVW R26,R28
	ADIW R26,14
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
;    1054 							buff3[j] = 0x0;
	MOVW R26,R28
	ADIW R26,14
_0x18E:
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(0)
	ST   X,R30
;    1055 						}
;    1056 					}
_0xCF:
_0xCA:
;    1057 					ch = buff[i++];
	CALL SUBOPT_0x1C
;    1058 				}
	RJMP _0xC4
_0xC6:
;    1059 				if(cnt == 2){			// ˻ 
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,2
	BRNE _0xD0
;    1060 					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
	CALL SUBOPT_0x1D
;    1061 					ecnt = (unsigned int)atoh(buff2);// ī ּ ȯ(HEX)
;    1062 					uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
	MOVW R30,R28
	ADIW R30,14
	CALL SUBOPT_0x21
	MOV  R16,R30
;    1063 					for(i = 0; i <= ecnt; i++,saddr++) EEPROM_write(saddr,uch);//  
	__GETWRN 18,19,0
_0xD2:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R30,R18
	CPC  R31,R19
	BRLO _0xD3
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R16
	RCALL _EEPROM_write
;    1064 					printf("SRAM Data Write OK\r\n");
	CALL SUBOPT_0x20
	RJMP _0xD2
_0xD3:
	__POINTW1FN _0,2937
	CALL SUBOPT_0xB
;    1065 				}
;    1066 			}
_0xD0:
;    1067 			else putchar(com1_rx_data);		// ݼ
	RJMP _0xD4
_0xC3:
	ST   -Y,R5
	CALL _putchar
;    1068 			com1_rx_eflg = 0;
_0xD4:
_0xC2:
_0xB0:
	CLR  R4
;    1069 		}
;    1070 	}
_0xAE:
	RJMP _0xAB
_0xAD:
;    1071 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;    1072 }
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,63
	ADIW R28,63
	ADIW R28,15
	RET
;    1073 
;    1074 // ============================== EEPROM DATA READ ============================
;    1075 // [μ] int addr
;    1076 // Item1:  ּ(0 - 4095)
;    1077 // []  (00 - ff)
;    1078 // ----------------------------------------------------------------------------
;    1079 unsigned char EEPROM_read(int addr)
;    1080 {
_EEPROM_read:
;    1081 unsigned char ch;
;    1082 
;    1083 	while(EECR & 0x02);					//   Ϸñ 
	ST   -Y,R17
;	addr -> Y+1
;	ch -> R17
_0xD5:
	SBIC 0x1C,1
	RJMP _0xD5
;    1084 	EEAR = addr;
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	OUT  0x1E+1,R31
	OUT  0x1E,R30
;    1085 	EECR |= 0x01;
	SBI  0x1C,0
;    1086 	ch = EEDR;
	IN   R17,29
;    1087 	return(ch);
	MOV  R30,R17
	LDD  R17,Y+0
	RJMP _0x18A
;    1088 }
;    1089 
;    1090 // ================================= EEPROM DATA  =========================
;    1091 // [μ] int addr,unsigned char data
;    1092 // Item1:  ּ(0 - 4095)
;    1093 // Item2:  (00 - ff)
;    1094 // ----------------------------------------------------------------------------
;    1095 void EEPROM_write(int addr,unsigned char data)
;    1096 {
_EEPROM_write:
;    1097 	while(EECR & 0x02);					//   Ϸñ 
;	addr -> Y+1
;	data -> Y+0
_0xD8:
	SBIC 0x1C,1
	RJMP _0xD8
;    1098 	EEAR = addr;
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	OUT  0x1E+1,R31
	OUT  0x1E,R30
;    1099 	EEDR = data;
	LD   R30,Y
	OUT  0x1D,R30
;    1100 	EECR |= 0x04;
	SBI  0x1C,2
;    1101 	EECR |= 0x02;
	SBI  0x1C,1
;    1102 }
_0x18A:
	ADIW R28,3
	RET
;    1103 
;    1104 // ============================== SRAM ׽Ʈ α׷ ========================
;    1105 // [μ] void
;    1106 // ---------------------------------------------------------------------------
;    1107 void sram_test(void)
;    1108 {
_sram_test:
;    1109 char ch,buff[100],buff1[30],buff2[30],buff3[30];
;    1110 unsigned char uch;
;    1111 int i,j,cnt,exit_flg = 0;
;    1112 unsigned int saddr,ecnt;
;    1113 unsigned char *sram_base = (unsigned char*)0x0;
;    1114 
;    1115 	printf("============ SRAM TEST ============\r\n");
	SBIW R28,63
	SBIW R28,63
	SBIW R28,63
	SBIW R28,11
	LDI  R24,8
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0xDB*2)
	LDI  R31,HIGH(_0xDB*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	ch -> R17
;	buff -> Y+106
;	buff1 -> Y+76
;	buff2 -> Y+46
;	buff3 -> Y+16
;	uch -> R16
;	i -> R18,R19
;	j -> R20,R21
;	cnt -> Y+14
;	exit_flg -> Y+12
;	saddr -> Y+10
;	ecnt -> Y+8
;	*sram_base -> Y+6
	__POINTW1FN _0,2958
	CALL SUBOPT_0xB
;    1116 	printf("- 0 : TOP MENU                    -\r\n");
	__POINTW1FN _0,2996
	CALL SUBOPT_0xB
;    1117 	printf("- 1 : Read  Data(0000-ffffh)      -\r\n");
	__POINTW1FN _0,3034
	CALL SUBOPT_0xB
;    1118 	printf("- 2 : Write Data(0000-ffffh)      -\r\n");
	__POINTW1FN _0,3072
	CALL SUBOPT_0xB
;    1119 	printf("-----------------------------------\r\n");
	__POINTW1FN _0,784
	CALL SUBOPT_0xB
;    1120 // External SRAM page configuration:
;    1121 //              -              / 0000h - FFFFh
;    1122 // Lower page wait state(s): None
;    1123 // Upper page wait state(s): None
;    1124 	MCUCR=0x80;
	LDI  R30,LOW(128)
	OUT  0x35,R30
;    1125 	XMCRA=0x00;
	LDI  R30,LOW(0)
	STS  109,R30
;    1126 
;    1127 	com1_rx_eflg = 0;
	CLR  R4
;    1128 	while(exit_flg == 0){
_0xDC:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BREQ PC+3
	JMP _0xDE
;    1129 	    if(com1_rx_eflg == 1){
	LDI  R30,LOW(1)
	CP   R30,R4
	BREQ PC+3
	JMP _0xDF
;    1130 			com1_rx_eflg = 0;
	CLR  R4
;    1131 			switch(com1_rx_data){
	MOV  R30,R5
;    1132 			    case   '0': exit_flg = 1; break;
	CPI  R30,LOW(0x30)
	BRNE _0xE3
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+12,R30
	STD  Y+12+1,R31
	RJMP _0xE2
;    1133 			    case   '1': i = j = cnt = 0;
_0xE3:
	CPI  R30,LOW(0x31)
	BREQ PC+3
	JMP _0xE4
	CALL SUBOPT_0x22
;    1134 					printf("\r\nREAD(#####(A),***(C)) > ");
	__POINTW1FN _0,3110
	CALL SUBOPT_0xB
;    1135 					urx_string(buff);
	CALL SUBOPT_0x23
;    1136 					ch = buff[i++];		//  ˻ ڷ 
;    1137 					while(ch != 0x0){
_0xE5:
	CPI  R17,0
	BREQ _0xE7
;    1138 				    		if((ch == ':') || (ch == ',') || (ch == ' ')){
	CPI  R17,58
	BREQ _0xE9
	CPI  R17,44
	BREQ _0xE9
	CPI  R17,32
	BRNE _0xE8
_0xE9:
;    1139 							j = 0;
	CALL SUBOPT_0x24
;    1140 							cnt++;
;    1141 						}
;    1142 						else{
	RJMP _0xEB
_0xE8:
;    1143 							if(cnt == 0){
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SBIW R30,0
	BRNE _0xEC
;    1144 					    			buff1[j++] = ch;
	CALL SUBOPT_0x19
	CALL SUBOPT_0x25
;    1145 								buff1[j] = 0x0;
	RJMP _0x18F
;    1146 							}
;    1147 							else if(cnt == 1){
_0xEC:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,1
	BRNE _0xEE
;    1148 					    			buff2[j++] = ch;
	CALL SUBOPT_0x19
	CALL SUBOPT_0x26
;    1149 					    			buff2[j] = 0x0;
_0x18F:
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(0)
	ST   X,R30
;    1150 							}
;    1151 				    		}
_0xEE:
_0xEB:
;    1152 					    		ch = buff[i++];
	CALL SUBOPT_0x27
;    1153 					}
	RJMP _0xE5
_0xE7:
;    1154 					if(cnt == 1){		// ˻ 
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,1
	BREQ PC+3
	JMP _0xEF
;    1155 						saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
	MOVW R30,R28
	SUBI R30,LOW(-(76))
	SBCI R31,HIGH(-(76))
	CALL SUBOPT_0x21
	CALL SUBOPT_0x28
;    1156 						ecnt = (unsigned int)atoh(buff2);// ī ȯ(HEX)
	STD  Y+8,R30
	STD  Y+8+1,R31
;    1157 						printf("%04X > ",saddr);// ּ ǥ
	__POINTW1FN _0,2859
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	CALL SUBOPT_0x1E
;    1158 						cnt = 0;
	LDI  R30,0
	STD  Y+14,R30
	STD  Y+14+1,R30
;    1159 				   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ
	__GETWRN 18,19,0
_0xF1:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CP   R30,R18
	CPC  R31,R19
	BRLO _0xF2
;    1160 							uch = sram_base[saddr];//  
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R16,X
;    1161 							printf("%02X ",uch);// Ÿ ǥ
	CALL SUBOPT_0x1F
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;    1162 							cnt++;
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADIW R30,1
	STD  Y+14,R30
	STD  Y+14+1,R31
;    1163 							if(cnt == 16){// 1 ǥ
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,16
	BRNE _0xF3
;    1164 								cnt = 0;
	LDI  R30,0
	STD  Y+14,R30
	STD  Y+14+1,R30
;    1165 								if(i+1 <= ecnt) printf("\r\n%04X > ",saddr+1);// ּ ǥ
	MOVW R26,R18
	ADIW R26,1
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CP   R30,R26
	CPC  R31,R27
	BRLO _0xF4
	__POINTW1FN _0,2873
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	CALL SUBOPT_0x1E
;    1166 							}
_0xF4:
;    1167 					    	}
_0xF3:
	CALL SUBOPT_0x29
	RJMP _0xF1
_0xF2:
;    1168 						printf("\r\nRead OK\r\n");
	__POINTW1FN _0,2883
	CALL SUBOPT_0xB
;    1169 					}
;    1170 					break;
_0xEF:
	RJMP _0xE2
;    1171 			    case  '2' : i = j = cnt = 0;
_0xE4:
	CPI  R30,LOW(0x32)
	BREQ PC+3
	JMP _0x106
	CALL SUBOPT_0x22
;    1172 					printf("\r\nWRITE(#####(A),***(C),**(D)) > ");
	__POINTW1FN _0,3137
	CALL SUBOPT_0xB
;    1173 					urx_string(buff);
	CALL SUBOPT_0x23
;    1174 					ch = buff[i++];		//  ˻ ڷ 
;    1175 					while(ch != 0x0){
_0xF6:
	CPI  R17,0
	BREQ _0xF8
;    1176 						if((ch == ':') || (ch == ',') || (ch == ' ')){
	CPI  R17,58
	BREQ _0xFA
	CPI  R17,44
	BREQ _0xFA
	CPI  R17,32
	BRNE _0xF9
_0xFA:
;    1177 							j = 0;
	CALL SUBOPT_0x24
;    1178 							cnt++;
;    1179 						}
;    1180 						else{
	RJMP _0xFC
_0xF9:
;    1181 							if(cnt == 0){
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SBIW R30,0
	BRNE _0xFD
;    1182 								buff1[j++] = ch;
	CALL SUBOPT_0x19
	CALL SUBOPT_0x25
;    1183 								buff1[j] = 0x0;
	RJMP _0x190
;    1184 							}
;    1185 							else if(cnt == 1){
_0xFD:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,1
	BRNE _0xFF
;    1186 								buff2[j++] = ch;
	CALL SUBOPT_0x19
	CALL SUBOPT_0x26
;    1187 								buff2[j] = 0x0;
	RJMP _0x190
;    1188 							}
;    1189 							else if(cnt == 2){
_0xFF:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,2
	BRNE _0x101
;    1190 								buff3[j++] = ch;
	CALL SUBOPT_0x19
	MOVW R26,R28
	ADIW R26,16
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
;    1191 								buff3[j] = 0x0;
	MOVW R26,R28
	ADIW R26,16
_0x190:
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(0)
	ST   X,R30
;    1192 							}
;    1193 						}
_0x101:
_0xFC:
;    1194 							    ch = buff[i++];
	CALL SUBOPT_0x27
;    1195 					}
	RJMP _0xF6
_0xF8:
;    1196 					if(cnt == 2){		// ˻ 
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,2
	BRNE _0x102
;    1197 						saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
	MOVW R30,R28
	SUBI R30,LOW(-(76))
	SBCI R31,HIGH(-(76))
	CALL SUBOPT_0x21
	CALL SUBOPT_0x28
;    1198 						ecnt = (unsigned int)atoh(buff2);// ī ּ ȯ(HEX)
	STD  Y+8,R30
	STD  Y+8+1,R31
;    1199 						uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
	MOVW R30,R28
	ADIW R30,16
	CALL SUBOPT_0x21
	MOV  R16,R30
;    1200 						for(i = 0; i <= ecnt; i++,saddr++){
	__GETWRN 18,19,0
_0x104:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CP   R30,R18
	CPC  R31,R19
	BRLO _0x105
;    1201 							sram_base[saddr] = uch;//  
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R16
;    1202 						}
	CALL SUBOPT_0x29
	RJMP _0x104
_0x105:
;    1203 //						for(i = 0; i < ecnt; i++) sram_base[saddr+i] = uch;//  
;    1204 						printf("SRAM Data Write OK\r\n");
	__POINTW1FN _0,2937
	CALL SUBOPT_0xB
;    1205 					}
;    1206 					break;
_0x102:
;    1207 		    	    default   : break;
_0x106:
;    1208 			}
_0xE2:
;    1209 		}
;    1210 	}
_0xDF:
	RJMP _0xDC
_0xDE:
;    1211 	com1_rx_eflg = 0;
	CLR  R4
;    1212 	main_menu_disp();					// ޴ ǥ
	CALL _main_menu_disp
;    1213 
;    1214 	MCUCR=0x00;						// clear exram config
	LDI  R30,LOW(0)
	OUT  0x35,R30
;    1215 	XMCRA=0x00;
	STS  109,R30
;    1216 }
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,63
	ADIW R28,63
	ADIW R28,17
	RET
;    1217 
;    1218 // ==================================== COM2 TEST =============================
;    1219 // [μ] void
;    1220 // ----------------------------------------------------------------------------
;    1221 void com2_test(void)
;    1222 {
_com2_test:
;    1223 int exit_flg = 0;
;    1224 
;    1225 	printf("============== COM2 LOOPBACK TEST ==============\r\n");
	CALL SUBOPT_0x11
;	exit_flg -> R16,R17
	__POINTW1FN _0,3171
	CALL SUBOPT_0xB
;    1226 	printf("- 0  : RETURN TOP MENU                          \r\n");
	__POINTW1FN _0,3222
	CALL SUBOPT_0xB
;    1227 	printf("------------------------------------------------\r\n");
	__POINTW1FN _0,771
	CALL SUBOPT_0xB
;    1228 
;    1229 	com1_rx_eflg = com2_rx_eflg = 0;
	LDI  R30,LOW(0)
	MOV  R6,R30
	MOV  R4,R30
;    1230 	while(exit_flg == 0){
_0x107:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x109
;    1231 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BREQ _0x10A
;    1232 			if(com1_rx_data == '0') exit_flg = 1;
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x10B
	__GETWRN 16,17,1
;    1233 			else putchar1(com1_rx_data);		// COM2 send
	RJMP _0x10C
_0x10B:
	ST   -Y,R5
	RCALL _putchar1
;    1234 			com1_rx_eflg = 0;
_0x10C:
	CLR  R4
;    1235 		}
;    1236 		if(com2_rx_eflg){				// COM2  ˻
_0x10A:
	TST  R6
	BREQ _0x10D
;    1237 			putchar(com2_rx_data);			// COM1 send
	ST   -Y,R7
	CALL _putchar
;    1238 			com2_rx_eflg = 0;
	CLR  R6
;    1239 		}
;    1240 	}
_0x10D:
	RJMP _0x107
_0x109:
;    1241 	main_menu_disp();					// ޴ ǥ
	CALL _main_menu_disp
;    1242 }
_0x189:
	LD   R16,Y+
	LD   R17,Y+
	RET
;    1243 
;    1244 // ============================ COM2 1Ʈ ۽ ===========================
;    1245 // [μ] char c
;    1246 // Item1  ۽ 
;    1247 // ----------------------------------------------------------------------------
;    1248 void putchar1(char c)
;    1249 {
_putchar1:
;    1250 	while((UCSR1A & DATA_REGISTER_EMPTY)==0);
;	c -> Y+0
_0x10E:
	LDS  R30,155
	ANDI R30,LOW(0x20)
	BREQ _0x10E
;    1251 	UDR1 = c;
	LD   R30,Y
	STS  156,R30
;    1252 }
_0x188:
	ADIW R28,1
	RET
;    1253 
;    1254 // ============================ κ ڿ  ====================
;    1255 // [μ] char buff[]
;    1256 // Item1   Ÿ  (ִ 30)
;    1257 // ----------------------------------------------------------------------------
;    1258 void urx_string(char buff[])
;    1259 {
_urx_string:
;    1260 char ch;
;    1261 int exit_flg = 0,scnt = 0;
;    1262 
;    1263 	com1_rx_eflg = 0;
	CALL __SAVELOCR6
;	*buff -> Y+6
;	ch -> R17
;	exit_flg -> R18,R19
;	scnt -> R20,R21
	LDI  R18,0
	LDI  R19,0
	LDI  R20,0
	LDI  R21,0
	CLR  R4
;    1264 	buff[0] = 0x0;						//  ũ
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
;    1265 	while(exit_flg == 0){
_0x111:
	MOV  R0,R18
	OR   R0,R19
	BREQ PC+3
	JMP _0x113
;    1266 	    while(com1_rx_eflg == 0); com1_rx_eflg = 0;		// 1 
_0x114:
	TST  R4
	BREQ _0x114
	CLR  R4
;    1267 	    ch = com1_rx_data;					//  Ÿ ε
	MOV  R17,R5
;    1268 	    ch = toupper(ch);					//  ȯ
	CALL SUBOPT_0x2A
;    1269 	    if(ch == 0x08){					// BSŰ м
	CPI  R17,8
	BRNE _0x117
;    1270 			if(scnt == 0) putchar(0x07);		//  溸 ۽
	MOV  R0,R20
	OR   R0,R21
	BRNE _0x118
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _putchar
;    1271 			else{					// 1ڸ 
	RJMP _0x119
_0x118:
;    1272 			    putchar(0x08);
	CALL SUBOPT_0x2B
;    1273 			    putchar(' ');
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL _putchar
;    1274 			    putchar(0x08);
	CALL SUBOPT_0x2B
;    1275 			    scnt--;
	__SUBWRN 20,21,1
;    1276 			}
_0x119:
;    1277 	    }
;    1278 	    else if(ch == 0x0d){
	RJMP _0x11A
_0x117:
	CPI  R17,13
	BRNE _0x11B
;    1279 			exit_flg = 1;				// Ż  ON
	__GETWRN 18,19,1
;    1280 			buff[scnt] = 0x0;
	MOVW R30,R20
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1281 			printf("\r\n");
	CALL SUBOPT_0xA
;    1282 	    }
;    1283 	    else{
	RJMP _0x11C
_0x11B:
;    1284 			buff[scnt++] = ch;			// ڷ 
	CALL SUBOPT_0x19
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
;    1285 			putchar(ch);
	ST   -Y,R17
	CALL _putchar
;    1286 			if(scnt >= 30){ 			//   ʰ 
	__CPWRN 20,21,30
	BRLT _0x11D
;    1287 			    scnt = 29;
	__GETWRN 20,21,29
;    1288 			    putchar(0x08);
	CALL SUBOPT_0x2B
;    1289 			    putchar(0x07);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _putchar
;    1290 			}
;    1291 	    }
_0x11D:
_0x11C:
_0x11A:
;    1292 	}
	RJMP _0x111
_0x113:
;    1293 }
	CALL __LOADLOCR6
	ADIW R28,8
	RET
;    1294 
;    1295 // ========================== ASCII͸ HEXͷ ȯ ==================
;    1296 // [μ] unsigned char buff[]
;    1297 // Item1  ȯ 
;    1298 // [] 0 - 7fffffffh
;    1299 // ----------------------------------------------------------------------------
;    1300 long atoh(char buff[])
;    1301 {
_atoh:
;    1302 char ch;
;    1303 int i = 0;
;    1304 long data = 0;
;    1305 
;    1306 	ch = buff[i++]; 					//  ε
	SBIW R28,4
	LDI  R24,4
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x11E*2)
	LDI  R31,HIGH(_0x11E*2)
	CALL __INITLOCB
	CALL SUBOPT_0xC
;	*buff -> Y+8
;	ch -> R17
;	i -> R18,R19
;	data -> Y+4
	CALL SUBOPT_0x2C
;    1307 	ch = toupper(ch);					// 빮 ȯ
;    1308 	while(ch != 0){
_0x11F:
	CPI  R17,0
	BREQ _0x121
;    1309 		ch = ch - '0';              			// 0 - 9 ȯ
	SUBI R17,LOW(48)
;    1310 		if(ch > 9) ch = ch - 7;				// A - F ȯ
	CPI  R17,10
	BRLO _0x122
	SUBI R17,LOW(7)
;    1311 		if(ch < 0 || ch > 0x0f) ch = 0;			//  ˻
_0x122:
	CPI  R17,0
	BRLO _0x124
	CPI  R17,16
	BRLO _0x123
_0x124:
	LDI  R17,LOW(0)
;    1312 		else ch = ch & 0x0f;
	RJMP _0x126
_0x123:
	ANDI R17,LOW(15)
;    1313 		data = data << 4;				// ȯ  
_0x126:
	__GETD2S 4
	LDI  R30,LOW(4)
	CALL __LSLD12
	__PUTD1S 4
;    1314 		data |= ch;
	MOV  R30,R17
	__GETD2S 4
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ORD12
	__PUTD1S 4
;    1315 		ch = buff[i++];					//  ε
	CALL SUBOPT_0x2C
;    1316 		ch = toupper(ch);				// 빮 ȯ
;    1317 	}
	RJMP _0x11F
_0x121:
;    1318 	return(data);
	__GETD1S 4
	CALL __LOADLOCR4
	ADIW R28,10
	RET
;    1319 }

_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x127
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x129
	__CPWRN 16,17,2
	BRLO _0x12A
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x129:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x12A:
	RJMP _0x12B
_0x127:
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _putchar
_0x12B:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
_0x12C:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x12E
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x132
	CPI  R18,37
	BRNE _0x133
	LDI  R17,LOW(1)
	RJMP _0x134
_0x133:
	CALL SUBOPT_0x2D
_0x134:
	RJMP _0x131
_0x132:
	CPI  R30,LOW(0x1)
	BRNE _0x135
	CPI  R18,37
	BRNE _0x136
	CALL SUBOPT_0x2D
	RJMP _0x191
_0x136:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x137
	LDI  R16,LOW(1)
	RJMP _0x131
_0x137:
	CPI  R18,43
	BRNE _0x138
	LDI  R20,LOW(43)
	RJMP _0x131
_0x138:
	CPI  R18,32
	BRNE _0x139
	LDI  R20,LOW(32)
	RJMP _0x131
_0x139:
	RJMP _0x13A
_0x135:
	CPI  R30,LOW(0x2)
	BRNE _0x13B
_0x13A:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x13C
	ORI  R16,LOW(128)
	RJMP _0x131
_0x13C:
	RJMP _0x13D
_0x13B:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x131
_0x13D:
	CPI  R18,48
	BRLO _0x140
	CPI  R18,58
	BRLO _0x141
_0x140:
	RJMP _0x13F
_0x141:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x131
_0x13F:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x145
	CALL SUBOPT_0x2E
	LD   R30,X
	CALL SUBOPT_0x2F
	RJMP _0x146
_0x145:
	CPI  R30,LOW(0x73)
	BRNE _0x148
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x30
	CALL _strlen
	MOV  R17,R30
	RJMP _0x149
_0x148:
	CPI  R30,LOW(0x70)
	BRNE _0x14B
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x30
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x149:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x14C
_0x14B:
	CPI  R30,LOW(0x64)
	BREQ _0x14F
	CPI  R30,LOW(0x69)
	BRNE _0x150
_0x14F:
	ORI  R16,LOW(4)
	RJMP _0x151
_0x150:
	CPI  R30,LOW(0x75)
	BRNE _0x152
_0x151:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x153
_0x152:
	CPI  R30,LOW(0x58)
	BRNE _0x155
	ORI  R16,LOW(8)
	RJMP _0x156
_0x155:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x187
_0x156:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x153:
	SBRS R16,2
	RJMP _0x158
	CALL SUBOPT_0x2E
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x159
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x159:
	CPI  R20,0
	BREQ _0x15A
	SUBI R17,-LOW(1)
	RJMP _0x15B
_0x15A:
	ANDI R16,LOW(251)
_0x15B:
	RJMP _0x15C
_0x158:
	CALL SUBOPT_0x2E
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x15C:
_0x14C:
	SBRC R16,0
	RJMP _0x15D
_0x15E:
	CP   R17,R21
	BRSH _0x160
	SBRS R16,7
	RJMP _0x161
	SBRS R16,2
	RJMP _0x162
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x163
_0x162:
	LDI  R18,LOW(48)
_0x163:
	RJMP _0x164
_0x161:
	LDI  R18,LOW(32)
_0x164:
	CALL SUBOPT_0x2D
	SUBI R21,LOW(1)
	RJMP _0x15E
_0x160:
_0x15D:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x165
_0x166:
	CPI  R19,0
	BREQ _0x168
	SBRS R16,3
	RJMP _0x169
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x192
_0x169:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x192:
	ST   -Y,R30
	CALL SUBOPT_0x31
	CPI  R21,0
	BREQ _0x16B
	SUBI R21,LOW(1)
_0x16B:
	SUBI R19,LOW(1)
	RJMP _0x166
_0x168:
	RJMP _0x16C
_0x165:
_0x16E:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x170:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x172
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x170
_0x172:
	CPI  R18,58
	BRLO _0x173
	SBRS R16,3
	RJMP _0x174
	SUBI R18,-LOW(7)
	RJMP _0x175
_0x174:
	SUBI R18,-LOW(39)
_0x175:
_0x173:
	SBRC R16,4
	RJMP _0x177
	CPI  R18,49
	BRSH _0x179
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x178
_0x179:
	RJMP _0x193
_0x178:
	CP   R21,R19
	BRLO _0x17D
	SBRS R16,0
	RJMP _0x17E
_0x17D:
	RJMP _0x17C
_0x17E:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x17F
	LDI  R18,LOW(48)
_0x193:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x180
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x31
	CPI  R21,0
	BREQ _0x181
	SUBI R21,LOW(1)
_0x181:
_0x180:
_0x17F:
_0x177:
	CALL SUBOPT_0x2D
	CPI  R21,0
	BREQ _0x182
	SUBI R21,LOW(1)
_0x182:
_0x17C:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x16F
	RJMP _0x16E
_0x16F:
_0x16C:
	SBRS R16,0
	RJMP _0x183
_0x184:
	CPI  R21,0
	BREQ _0x186
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x2F
	RJMP _0x184
_0x186:
_0x183:
_0x187:
_0x146:
_0x191:
	LDI  R17,LOW(0)
_0x131:
	RJMP _0x12C
_0x12E:
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G2
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	OUT  0x1A,R30
	OUT  0x18,R30
	OUT  0x17,R30
	OUT  0x15,R30
	OUT  0x14,R30
	OUT  0x12,R30
	OUT  0x11,R30
	OUT  0x3,R30
	OUT  0x2,R30
	STS  98,R30
	STS  97,R30
	STS  101,R30
	STS  100,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	OUT  0x30,R30
	OUT  0x33,R30
	OUT  0x32,R30
	OUT  0x31,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	OUT  0x2F,R30
	OUT  0x2E,R30
	OUT  0x2D,R30
	OUT  0x2C,R30
	OUT  0x2B,R30
	OUT  0x2A,R30
	OUT  0x29,R30
	OUT  0x28,R30
	STS  121,R30
	STS  120,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(0)
	OUT  0x25,R30
	OUT  0x24,R30
	OUT  0x23,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(0)
	STS  139,R30
	STS  138,R30
	STS  137,R30
	STS  136,R30
	STS  135,R30
	STS  134,R30
	STS  133,R30
	STS  132,R30
	STS  131,R30
	STS  130,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(0)
	STS  106,R30
	OUT  0x3A,R30
	OUT  0x39,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(246)
	STS  137,R30
	LDI  R30,LOW(59)
	STS  136,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x9:
	ST   -Y,R30
	ST   -Y,R31
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA:
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 103 TIMES, CODE SIZE REDUCTION:405 WORDS
SUBOPT_0xB:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	CALL __SAVELOCR4
	LDI  R18,0
	LDI  R19,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xD:
	__POINTW1FN _0,718
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xE:
	__POINTW1FN _0,770
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(0)
	OUT  0x30,R30
	LDI  R30,LOW(7)
	OUT  0x33,R30
	LDI  R30,LOW(99)
	OUT  0x32,R30
	LDI  R30,LOW(0)
	OUT  0x31,R30
	IN   R30,0x37
	ORI  R30,1
	OUT  0x37,R30
	CLR  R8
	CLR  R9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x10:
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	CALL __LSLW12
	COM  R30
	COM  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x11:
	ST   -Y,R17
	ST   -Y,R16
	LDI  R16,0
	LDI  R17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x12:
	OUT  0x6,R30
	IN   R30,0x20
	ANDI R30,0xEF
	OUT  0x20,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x13:
	ST   -Y,R30
	CALL _ad_read
	MOVW R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x14:
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x15:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _printf
	ADIW R28,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STD  Y+12,R30
	STD  Y+12+1,R31
	MOVW R20,R30
	MOVW R18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x17:
	MOVW R30,R28
	SUBI R30,LOW(-(104))
	SBCI R31,HIGH(-(104))
	ST   -Y,R31
	ST   -Y,R30
	CALL _urx_string
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(104))
	SBCI R27,HIGH(-(104))
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x18:
	__GETWRN 20,21,0
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	STD  Y+12,R30
	STD  Y+12+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x19:
	MOVW R30,R20
	__ADDWRN 20,21,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1A:
	MOVW R26,R28
	SUBI R26,LOW(-(74))
	SBCI R27,HIGH(-(74))
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	MOVW R26,R28
	SUBI R26,LOW(-(74))
	SBCI R27,HIGH(-(74))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1B:
	MOVW R26,R28
	ADIW R26,44
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	MOVW R26,R28
	ADIW R26,44
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1C:
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(104))
	SBCI R27,HIGH(-(104))
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x1D:
	MOVW R30,R28
	SUBI R30,LOW(-(74))
	SBCI R31,HIGH(-(74))
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoh
	STD  Y+8,R30
	STD  Y+8+1,R31
	MOVW R30,R28
	ADIW R30,44
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoh
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x1E:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1F:
	__POINTW1FN _0,2867
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x20:
	__ADDWRN 18,19,1
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x21:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _atoh

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STD  Y+14,R30
	STD  Y+14+1,R31
	MOVW R20,R30
	MOVW R18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x23:
	MOVW R30,R28
	SUBI R30,LOW(-(106))
	SBCI R31,HIGH(-(106))
	ST   -Y,R31
	ST   -Y,R30
	CALL _urx_string
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(106))
	SBCI R27,HIGH(-(106))
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x24:
	__GETWRN 20,21,0
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADIW R30,1
	STD  Y+14,R30
	STD  Y+14+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x25:
	MOVW R26,R28
	SUBI R26,LOW(-(76))
	SBCI R27,HIGH(-(76))
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	MOVW R26,R28
	SUBI R26,LOW(-(76))
	SBCI R27,HIGH(-(76))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x26:
	MOVW R26,R28
	ADIW R26,46
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	MOVW R26,R28
	ADIW R26,46
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x27:
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(106))
	SBCI R27,HIGH(-(106))
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	STD  Y+10,R30
	STD  Y+10+1,R31
	MOVW R30,R28
	ADIW R30,46
	RJMP SUBOPT_0x21

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x29:
	__ADDWRN 18,19,1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,1
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2A:
	ST   -Y,R17
	CALL _toupper
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	LDI  R30,LOW(8)
	ST   -Y,R30
	JMP  _putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2C:
	MOVW R30,R18
	__ADDWRN 18,19,1
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RJMP SUBOPT_0x2A

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x2D:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x2E:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2F:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x30:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x31:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_toupper:
	ld   r30,y+
	cpi  r30,'a'
	brlo __toupper0
	cpi  r30,'z'+1
	brcc __toupper0
	subi r30,32
__toupper0:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ORD12:
	OR   R30,R26
	OR   R31,R27
	OR   R22,R24
	OR   R23,R25
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
